"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DeviceWorkstation subclass:#WinWorkstation
	instanceVariableNames:'blackpixel whitepixel
		listOfFonts rootWin rootDC
		buttonsPressed eventTrace
		eventBuffer
		usingSystemPalette
		captionHeight
		resizeFrameWidth resizeFrameHeight
		dialogFrameWidth dialogFrameHeight
		noResizeFrameWidth noResizeFrameHeight
		inRecursiveDispatch'
	classVariableNames:'RawKeysymTranslation BeepFrequency BeepDuration
			    NativeWindows NativeWindowClassTable'
	poolDictionaries:''
	category:'Interface-Graphics'
!

!WinWorkstation primitiveDefinitions!
%{

# undef INT
# define INT WIN_INT
# undef Array
# define Array WIN_Array
# undef Number
# define Number WIN_Number
# undef Method
# define Method WIN_Method
# undef Point
# define Point WIN_Point
# undef Rectangle
# define Rectangle WIN_Rectangle
# undef True
# define True WIN_True
# undef False
# define False WIN_False
# undef Block

# undef xxCONTEXT
# define xxCONTEXT        WIN_CONTEXT
# undef _xxCONTEXT
# define _xxCONTEXT       _WIN_CONTEXT



#include <stdio.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

#include <stdarg.h>

/* #include <windows.h> */

#  include <windef.h>
#  include <winbase.h>
#  include <wingdi.h>
#  include <winuser.h>

#include <windowsx.h>

#   ifdef __DEF_Array
#    undef Array
#    define Array __DEF_Array
#   endif
#   ifdef __DEF_Number
#    undef Number
#    define Number __DEF_Number
#   endif
#   ifdef __DEF_Method
#    undef Method
#    define Method __DEF_Method
#   endif
#   ifdef __DEF_Point
#    undef Point
#    define Point __DEF_Point
#   endif
#   ifdef __DEF_Block
#    define Block __DEF_Block
#   endif
#   undef INT
#   define INT int

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HBITMAPVAL(o)       (HBITMAP)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))
#define _HDCVal(o)           (_GCDATA(o)->hDC)
#define _HPENVal(o)          (_GCDATA(o)->hPen)
#define _HBRUSHVal(o)        (_GCDATA(o)->hBrush)

#define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#define ISCONNECTED          (__INST(rootDC) != nil)

struct gcData {
    HDC         hDC;
    HPEN        hPen;
    HBRUSH      hBrush;
    COLORREF    fgColor;
    COLORREF    bgColor;
    int         brushType;
    int         lineWidth;
    int         lineStyle;
    int         joinStyle;
    int         capStyle;
    int         fontAscent;
    HRGN	clipRgn;
};

/*
 * some synthetic values
 */
# define Button1MotionMask      1
# define Button2MotionMask      2
# define Button3MotionMask      4

# define Button1Mask            Button1MotionMask
# define Button2Mask            Button2MotionMask
# define Button3Mask            Button3MotionMask

# define ControlMask            8
# define ShiftMask              16
# define LeftAltMask            32
# define RightAltMask           64

# define TRANSLATED_KEY         256

/*
 * synthetic events
 */
#define __WM_MOUSEENTER        0x10001
#define __WM_MOUSELEAVE        0x10002
#define __WM_SIZEMOVE          0x10003

static int AltMask = RightAltMask;
static int MetaMask = LeftAltMask;

# define WhitePixel     RGB(0xFF, 0xFF, 0xFF)
# define BlackPixel     RGB(0, 0, 0)

#ifdef DEBUG
# define DPRINTF(x)             { if (__debug__) printf x;}
# define DDPRINTF(x)            /* nothing */
# define EVENT_PRINTF(x)        { if (__debug__) printf x;}
# define EVENT_PRINTF1(x)       /* */
# define EVENT_PRINTF2(x)       { if (__debug__) printf x;}
# define EVENT_PRINTF3(x)       /* */
#else
# define DPRINTF(x)             /* */
# define DDPRINTF(x)            /* */
# define EVENT_PRINTF(x)        /* */
# define EVENT_PRINTF1(x)       /* */
# define EVENT_PRINTF2(x)       /* */
# define EVENT_PRINTF3(x)       /* */
#endif

# define BR_SOLID       0
# define BR_PATTERN     1

# define LINE_SOLID     0
# define LINE_DASH      1
# define LINE_DDASH     2

#ifdef KEEP_STD_CURSORS
# define _C_ARROW       1
# define _C_CROSS       2
# define _C_IBEAM       3
# define _C_ICON        4
# define _C_NO          5
# define _C_SIZE        6
# define _C_SIZEALL     7
# define _C_SIZENESW    8
# define _C_SIZENS      9
# define _C_SIZENWSE    10
# define _C_UPARROW     11
# define _C_WAIT        12

 static HCURSOR H_C_ARROW = (HCURSOR)0;
 static HCURSOR H_C_CROSS = (HCURSOR)0;
 static HCURSOR H_C_IBEAM = (HCURSOR)0;
 static HCURSOR H_C_ICON = (HCURSOR)0;
 static HCURSOR H_C_NO = (HCURSOR)0;
 static HCURSOR H_C_SIZE = (HCURSOR)0;
 static HCURSOR H_C_SIZEALL = (HCURSOR)0;
 static HCURSOR H_C_SIZENESW = (HCURSOR)0;
 static HCURSOR H_C_SIZENS = (HCURSOR)0;
 static HCURSOR H_C_SIZENWSE = (HCURSOR)0;
 static HCURSOR H_C_UPARROW = (HCURSOR)0;
 static HCURSOR H_C_WAIT = (HCURSOR)0;
#endif /* KEEP_STD_CURSORS */

static int evRootX, evRootY;
static HWND buttonWindow = (HWND)0;

%}
! !

!WinWorkstation primitiveVariables!
%{

static HANDLE hInstance = (HANDLE)0, 
	  hPrevInstance = (HANDLE)0;
static int firstInstance = 1;
static char *app_name = "ST/X";
static int __debug__ = 0;

static int inCreate = 0;
static int inSizeMove = 0;
static int inSpecialMove = 0;
static int inSTXEscape = 0;
static int lastNCMouseX, lastNCMouseY;
static int lastMoveX, lastMoveY, lastSizeWidth, lastSizeHeight;
static int create_topView;
static int create_minWidth;
static int create_maxWidth;
static int create_minHeight;
static int create_maxHeight;
static HANDLE currentPointerView = (HANDLE)0;
static HBRUSH bgBrush = (HBRUSH)0;

%}
! !

!WinWorkstation primitiveFunctions!

%{

struct queuedEvent {
	struct queuedEvent     *ev_next;
	HWND                    ev_hWnd;
	UINT                    ev_message;
	UINT                    ev_wParam;
	int                     ev_arg1;
	int                     ev_arg2;
	int                     ev_arg3;
	int                     ev_arg4;
	int                     filler;
};

#define ev_x    ev_arg1
#define ev_y    ev_arg2
#define ev_w    ev_arg3
#define ev_h    ev_arg4

#define ev_keyCode   ev_wParam
#define ev_scanCode  ev_arg3
#define ev_modifiers ev_arg4

#define EV_CHUNK_SZ     1024
#define EV_CHUNK_CNT    (1024/sizeof(struct queuedEvent))
struct queuedEvent *eventFreeList = (struct queuedEvent *)0;
struct queuedEvent *eventQueueHead = (struct queuedEvent *)0;
struct queuedEvent *eventQueueTail = (struct queuedEvent *)0;

__debugEvent__() {}

static
enqEvent(hWnd, message, wParam, arg1, arg2, arg3, arg4)
    HWND hWnd;
    UINT message;
    UINT wParam;
{
    struct queuedEvent *ev;
    struct queuedEvent *bulk;
    int i;

    ev = eventFreeList;
    if (ev) {
	eventFreeList = ev->ev_next;
    } else {
	bulk = (struct queuedEvent *) malloc(EV_CHUNK_SZ);
	for (i=1; i<EV_CHUNK_CNT; i++) {
	    bulk[i-1].ev_next = &(bulk[i]);
	}
	bulk[EV_CHUNK_CNT-1].ev_next = (struct queuedEvent *)0;
	ev = bulk;
	eventFreeList = &(bulk[1]);
    }

    ev->ev_next = (struct queuedEvent *)0;
    ev->ev_hWnd = hWnd;
    ev->ev_message = message;
    ev->ev_wParam = wParam;
    ev->ev_arg1 = arg1;
    ev->ev_arg2 = arg2;
    ev->ev_arg3 = arg3;
    ev->ev_arg4 = arg4;

    if (eventQueueTail) {
	eventQueueTail->ev_next = ev;
    } else {
	eventQueueHead = ev;
    }
    eventQueueTail = ev;
}

static
struct queuedEvent *
deqEvent() {
    struct queuedEvent *ev;

    ev = eventQueueHead;
    if (ev) {
	eventQueueHead = ev->ev_next;
	if (! eventQueueHead) {
	    eventQueueTail = (struct queuedEvent *)0;
	}
    }

    return ev;
}

static
freeEvent(ev)
    struct queuedEvent *ev;
{
    ev->ev_next = eventFreeList;
    eventFreeList = ev;
}

static
getModifiers()
{
    int modifiers;

    modifiers = 0;
    if (GetKeyState(VK_SHIFT) & 0x8000)
	modifiers |= ShiftMask;
    if (GetKeyState(VK_CONTROL) & 0x8000)
	modifiers |= ControlMask;
    if (GetKeyState(VK_RMENU) & 0x8000)
	modifiers |= RightAltMask;
    if (GetKeyState(VK_LMENU) & 0x8000)
	modifiers |= LeftAltMask;
    if (GetKeyState(VK_LBUTTON) & 0x8000)
	modifiers |= Button1Mask;
    if (GetKeyState(VK_MBUTTON) & 0x8000)
	modifiers |= Button2Mask;
    if (GetKeyState(VK_RBUTTON) & 0x8000)
	modifiers |= Button3Mask;

    return modifiers;
}

static
getWinEvents(all)
{
    MSG msg;
    int more;
#ifdef CALLLEVEL_DEBUG
    static int callLevel = 0;
#endif

    if (inSizeMove) return;

    if (GetQueueStatus(QS_ALLINPUT) && PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE)) {
	more = 1;

#ifdef CALLLEVEL_DEBUG
	DPRINTF(("(%d\n", callLevel)); callLevel++;
#endif

	while (more) {
	    GetMessage(&msg, (HWND)0, 0, 0);

	    if ((msg.message == WM_KEYDOWN) || (msg.message == WM_KEYUP)
	     || (msg.message == WM_SYSKEYDOWN) || (msg.message == WM_SYSKEYUP)) {
		if (((msg.wParam >= '0') && (msg.wParam <= 'Z'))
		 || (msg.wParam == 0x20)
		 || (msg.wParam >= 0xB0)) {
		    /* 
		     * translate to a WM_CHAR message
		     */
		    if (TranslateMessage(&msg))
			continue;
		}
	    }

	    evRootX = msg.pt.x;
	    evRootY = msg.pt.y;
	    DDPRINTF(("..... > dispatch\n"));
	    DispatchMessage(&msg);
	    DDPRINTF(("..... < dispatch\n"));

	    if (! all) {
		break;
	    } else {
		more = PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE);
	    }
	}
#ifdef CALLLEVEL_DEBUG
	callLevel--; DPRINTF((")%d\n", callLevel));
#endif
    }
}

static
winEventProcessing(hWnd, message, wParam, lParam, pDefault)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
    int *pDefault;
{
    LPMINMAXINFO lpmmi;
    WINDOWPOS *posStruct;
    RECT rct;
    RECT upd;
    int modifiers;
    int x, y, w, h;
    int isNative = 0;

/*
    EVENT_PRINTF(("winEvent hWin=0x%x message=0x%x wP=0x%x lP=0x%x\n", 
			hWnd, message, wParam, lParam));
*/

    /*
     * messages which are handled right here 
     */
    if (inCreate) {
	EVENT_PRINTF(("in create\n"));

	switch (message) {
	    case WM_GETMINMAXINFO:
		if (create_topView) {
		    lpmmi = (LPMINMAXINFO) lParam;

		    DPRINTF(("WM_GETMINMAXINFO handle=%x got min: %d/%d\n",
				hWnd,
				lpmmi->ptMinTrackSize.x,
				lpmmi->ptMinTrackSize.y));
                                 

		    lpmmi->ptMaxSize.x = create_maxWidth;
		    lpmmi->ptMaxSize.y = create_maxHeight;
		    lpmmi->ptMaxTrackSize.x = create_maxWidth;
		    lpmmi->ptMaxTrackSize.y = create_maxHeight;
		    lpmmi->ptMinTrackSize.x = create_minWidth;
		    lpmmi->ptMinTrackSize.y = create_minHeight;
		    DPRINTF(("WM_GETMINMAXINFO handle=%x return min: %d/%d max: %d/%d\n", 
				    hWnd,
				    create_minWidth, create_minHeight,
				    create_maxWidth, create_maxHeight));
		    *pDefault = 0;
		    return 0;
		}
		break;
	}
    }

    /*
     * messages which are enqueued to be handled by the view thread
     */
    if (hWnd) {
	if (GetWindowLong(hWnd, GWL_STYLE) 
	    & (BS_RADIOBUTTON | BS_CHECKBOX | SBS_HORZ | SBS_VERT)) {
	    /*
	     * a native window ...
	     */
	    isNative = 1;
	    printf("native window\n");
	}
    }

    switch (message) {
	case WM_SETCURSOR:
	    *pDefault = 1;
	    return 0;

	case WM_WINDOWPOSCHANGED:
	    /*
	     * ignore child window messages ...
	     */
	    if (GetParent(hWnd)) {
		break;
	    }

	    EVENT_PRINTF(("WM_WINDOWPOSCHANGED\n"));
	    posStruct = (WINDOWPOS *)lParam;
	    if (! posStruct) {
		DPRINTF(("oops - no posStruct passed\n"));
		break;
	    }

	    if (1 /* ! inSizeMove */) {
		GetClientRect(hWnd, &rct);
		enqEvent(hWnd, message, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);
	    } else {
		EVENT_PRINTF(("**** WM_WINDOWPOSCHANGED ignored\n"));
	    }

	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }

/*
	    *pDefault = 0;
*/
	    *pDefault = 1;
	    return 0;

	case WM_EXITSIZEMOVE:
	    EVENT_PRINTF(("WM_EXITSIZEMOVE\n"));
	    inSizeMove = 0;
	    if (bgBrush) {
		DeleteObject(bgBrush);
		bgBrush = (HBRUSH)0;
	    }
	    GetClientRect(hWnd, &rct);
	    enqEvent(hWnd, __WM_SIZEMOVE, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);

	    *pDefault = 0;
	    return 0;
	    break;

	case WM_ENTERSIZEMOVE:
	    EVENT_PRINTF(("WM_ENTERSIZEMOVE\n"));
	    GetClientRect(hWnd, &rct);
	    lastMoveX = rct.left;
	    lastMoveY = rct.top;
	    lastSizeWidth = rct.right-rct.left+1;
	    lastSizeHeight = rct.bottom-rct.top+1;
	    inSizeMove = 1;

	    *pDefault = 0;
/*
	    *pDefault = 1;
*/
	    return 0;

	case WM_SIZE:
	    EVENT_PRINTF(("WM_SIZE\n"));
	    if (inSizeMove) {
		lastSizeWidth = LOWORD(lParam);
		lastSizeHeight = HIWORD(lParam);
		EVENT_PRINTF(("**** WM_SIZE ignored\n"));
	    } else {
		GetClientRect(hWnd, &rct);
		enqEvent(hWnd, __WM_SIZEMOVE, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);
	    }
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return 0;
	    break;

	case WM_MOVE:
	    EVENT_PRINTF(("WM_MOVE\n"));
	    if (inSizeMove) {
		lastMoveX = LOWORD(lParam);
		lastMoveY = HIWORD(lParam);
		EVENT_PRINTF(("**** WM_MOVE ignored\n"));
	    } else {
		GetClientRect(hWnd, &rct);
		enqEvent(hWnd, __WM_SIZEMOVE, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);
	    }
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return 0;
	    break;

	case WM_ERASEBKGND:
	    EVENT_PRINTF(("WM_ERASEBKGND\n"));

	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }

	    if (GetUpdateRect(hWnd, &upd, 0)) {
		DWORD bg;
		HDC dc;

		if ((upd.left == upd.right) && (upd.top == upd.bottom)) {
		    DPRINTF(("WM_ERASEBKGND: null rectangle\n"));
/*
		    ValidateRect(hWnd, NULL);
*/
		    break;
		}

		x = upd.left;
		y = upd.top;
		w = upd.right - upd.left + 1;
		h = upd.bottom - upd.top + 1;

/*
		ValidateRect(hWnd, NULL);
*/
		ValidateRect(hWnd, &upd);

		if (inSizeMove) {
		    if (! bgBrush) {
		        bg = GetSysColor(COLOR_WINDOW);
		        bgBrush = CreateSolidBrush (bg);
		    }
		    dc = GetDC(hWnd);
		    FillRect(dc, &upd, bgBrush);
	            /* DeleteObject(brush); */
		}

		enqEvent(hWnd, message, wParam, x, y, w, h);
	    }

/*
	    *pDefault = 1;
*/
	    *pDefault = 0;
	    return 1;
	    break;

	case WM_PAINT:
	    EVENT_PRINTF(("WM_PAINT\n"));
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    if (GetUpdateRect(hWnd, &upd, 0)) {
		if ((upd.left == upd.right) && (upd.top == upd.bottom)) {
		    DPRINTF(("WM_PAINT: null rectangle\n"));
		    ValidateRect(hWnd, NULL);
		    break;
		}

		x = upd.left;
		y = upd.top;
		w = upd.right - upd.left + 1;
		h = upd.bottom - upd.top + 1;

		enqEvent(hWnd, message, wParam, x, y, w, h);
		break;

		ValidateRect(hWnd, &upd);
/*
		ValidateRect(hWnd, NULL);
*/

	    }

	    *pDefault = 0;
	    return 0;
	    break;

	case WM_SHOWWINDOW:
	    EVENT_PRINTF(("WM_SHOWWINDOW\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return 0;

	case WM_DESTROY:
	    EVENT_PRINTF2(("WM_DESTROY\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEACTIVATE:
	    EVENT_PRINTF2(("WM_MOUSEACTIVATE h=%x\n", hWnd));
	    SetFocus(hWnd);
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);

	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return MA_ACTIVATE;
/*
	    *pDefault = 0;
	    return MA_ACTIVATE;
*/
	    return MA_ACTIVATEANDEAT;

	case WM_ACTIVATE:
	    EVENT_PRINTF2(("WM_ACTIVATE %s h=%x\n", 
			    LOWORD(wParam) ? "active" : "inactive",
			    hWnd));

	    switch (LOWORD(wParam)) {
		case WA_INACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE inactive h=%x\n", hWnd));
		    break;
		case WA_ACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE active h=%x\n", hWnd));
		    break;
		case WA_CLICKACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE clkactive h=%x\n", hWnd));
		    break;
		default:
		    EVENT_PRINTF2(("WM_ACTIVATE ? h=%x\n", hWnd));
		    break;
	    }
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    return 0;

	case WM_SYSCHAR:
	    EVENT_PRINTF2(("WM_SYSCHAR h=%x %x\n", hWnd, wParam));
	    goto commonChar;

	case WM_CHAR:
	    EVENT_PRINTF2(("WM_CHAR h=%x %x\n", hWnd, wParam));
	commonChar:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }
	    enqEvent(hWnd, WM_KEYDOWN, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    enqEvent(hWnd, WM_KEYUP, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    *pDefault = 0;
	    return 0;
         
	case WM_SYSKEYUP:
	    EVENT_PRINTF2(("WM_SYSKEYUP %x\n, wParam"));
	    goto commonKey;

	case WM_SYSKEYDOWN:
	    EVENT_PRINTF2(("WM_SYSKEYDOWN %x\n, wParam"));
	    goto commonKey;

	case WM_KEYUP:
	    EVENT_PRINTF2(("WM_KEYUP h=%x %x\n", hWnd, wParam));
	    goto commonKey;

	case WM_KEYDOWN:
	    EVENT_PRINTF2(("WM_KEYDOWN h=%x %x\n", hWnd, wParam));
	commonKey:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }

	    enqEvent(hWnd, message, wParam, x, y, lParam, modifiers);
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEMOVE:
	    EVENT_PRINTF3(("WM_MOUSEMOVE h=%x\n", hWnd));
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    if (inSizeMove) {
		*pDefault = 1;
		return 0;
	    }

	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);

	        modifiers = getModifiers();

		if (hWnd != currentPointerView) {
		    if (currentPointerView) {
			enqEvent(currentPointerView, __WM_MOUSELEAVE, 0, -1, -1, 0, modifiers);
			currentPointerView = 0;
		    }
		    enqEvent(hWnd, __WM_MOUSEENTER, 0, x, y, 0, modifiers);
		    currentPointerView = hWnd;
		}
		enqEvent(hWnd, message, wParam, x, y, 0, modifiers);
	    }
	    *pDefault = 0;
	    return 0;
            
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    SetCapture(hWnd);
	    goto commonButton;

	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    ReleaseCapture();
	    goto commonButton;

	case WM_LBUTTONDBLCLK:
	case WM_MBUTTONDBLCLK:
	case WM_RBUTTONDBLCLK:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	commonButton:
	    modifiers = getModifiers();
	    EVENT_PRINTF3(("WM_BUTTONUP/DOWN h=%x pos=%d/%d\n", 
			   hWnd, LOWORD(lParam), HIWORD(lParam)));

	    enqEvent(hWnd, message, wParam, LOWORD(lParam),
					    HIWORD(lParam),
					    wParam,
					    modifiers);
	    *pDefault = 0;
	    return 0;

	case WM_KILLFOCUS:
	    EVENT_PRINTF(("WM_KILLFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    return 0;

	case WM_SETFOCUS:
	    EVENT_PRINTF(("WM_SETFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    return 0;
    }

    switch (message) {
	case WM_STYLECHANGING:
	    EVENT_PRINTF(("WM_STYLECHANGING\n"));
	    break;

	case WM_STYLECHANGED:
	    EVENT_PRINTF(("WM_STYLECHANGED\n"));
	    break;

	case WM_GETTEXT:
	    EVENT_PRINTF(("WM_GETTEXT %x\n", message));
	    break;

	case WM_GETTEXTLENGTH:
	    EVENT_PRINTF(("WM_GETTEXTLENGTH %x\n", message));
	    break;

	case WM_NCCREATE:
	    EVENT_PRINTF(("WM_NCCREATE %x\n", message));
	    break;

	case WM_GETMINMAXINFO:
	    EVENT_PRINTF(("WM_GETMINMAXINFO %x\n", message));
	    break;

	case WM_NCHITTEST:
	    EVENT_PRINTF3(("WM_NCHITTEST %x\n", message));
	    break;

	case WM_NCMOUSEMOVE:
	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);
	        EVENT_PRINTF(("WM_NCMOUSEMOVE %d/%d\n", x, y));
		lastNCMouseX = x;
		lastNCMouseY = y;
	    }
	    break;

	case WM_PARENTNOTIFY:
	    EVENT_PRINTF2(("WM_PARENTNOTIFY h=%x hChild=%x %d\n", 
				hWnd, lParam, LOWORD(wParam)));
	    break;

	case WM_SETCURSOR:
	    EVENT_PRINTF(("WM_SETCURSOR\n"));
	    break;

	case WM_NCLBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCLBUTTONDOWN\n"));
	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);
		lastNCMouseX = x;
		lastNCMouseY = y;
	    }
	    break;

	case WM_NCLBUTTONUP:
	    EVENT_PRINTF(("WM_NCLBUTTONUP\n"));
	    break;

	case WM_NCRBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCRBUTTONDOWN\n"));
	    break;

	case WM_NCRBUTTONUP:
	    EVENT_PRINTF(("WM_NCRBUTTONUP\n"));
	    break;

	case WM_NCMBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCMBUTTONDOWN\n"));
	    break;

	case WM_NCMBUTTONUP:
	    EVENT_PRINTF(("WM_NCMBUTTONUP\n"));
	    break;

	case WM_SETTEXT:
	    EVENT_PRINTF(("WM_SETTEXT\n"));
	    break;

	case 0x88:
	    EVENT_PRINTF(("0x88 (undoc)\n"));
	    break;

	case WM_CREATE:
	    EVENT_PRINTF(("WM_CREATE\n"));
	    break;

	case WM_NCCALCSIZE:
	    EVENT_PRINTF(("WM_NCCALCSIZE\n"));
	    break;

	case WM_NCPAINT:
	    EVENT_PRINTF3(("WM_NCPAINT\n"));
	    break;

	case WM_SYSCOMMAND:
	    switch (wParam & ~0x000F) {
		case SC_CLOSE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_CLOSE\n"));
		    break;

		case SC_MOVE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_MOVE\n"));
/*
		    inSpecialMove = 1;
		    *pDefault = 0;
		    return 0;
*/
		    break;

		case SC_RESTORE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_RESTORE\n"));
		    break;

		case SC_SIZE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_SIZE\n"));
		    break;

		default:
		    EVENT_PRINTF2(("WM_SYSCOMMAND %x\n", wParam));
		    break;
	    }
	    break;

	case WM_INITMENU:
	    EVENT_PRINTF(("WM_INITMENU\n"));
	    break;

	case WM_INITMENUPOPUP:
	    EVENT_PRINTF(("WM_INITMENUPOPUP\n"));
	    break;

	case WM_ENTERIDLE:
	    EVENT_PRINTF(("WM_ENTERIDLE\n"));
	    break;

	case WM_ENTERMENULOOP:
	    EVENT_PRINTF(("WM_ENTERMENULOOP\n"));
	    break;

	case WM_EXITMENULOOP:
	    EVENT_PRINTF(("WM_EXITMENULOOP\n"));
	    break;

	case WM_MENUSELECT:
	    EVENT_PRINTF(("WM_MENUSELECT\n"));
	    break;

	case WM_QUIT:
	    EVENT_PRINTF(("WM_QUIT\n"));
	    break;

	case WM_CLOSE:
	    EVENT_PRINTF(("WM_CLOSE\n"));
	    break;

	case WM_NCDESTROY:
	    EVENT_PRINTF(("WM_NCDESTROY\n"));
	    break;

	case WM_QUERYNEWPALETTE:
	    EVENT_PRINTF(("WM_QUERYNEWPALETTE\n"));
	    break;

	case WM_PALETTECHANGED:
	    EVENT_PRINTF(("WM_PALETTECHANGED\n"));
	    break;

	case WM_NCACTIVATE:
	    EVENT_PRINTF(("WM_NCACTIVATE\n"));
	    break;

	case WM_MOUSEACTIVATE:
	    EVENT_PRINTF2(("WM_MOUSEACTIVATE h=%x\n", hWnd));
	    break;

	case WM_ACTIVATEAPP:
	    EVENT_PRINTF1(("WM_ACTIVATEAPP %s\n", wParam ? "active" : "inactive"));
	    break;

	case WM_SYSDEADCHAR:
	    EVENT_PRINTF2(("WM_SYSDEADCHAR %x\n, wParam"));
	    break;

	case WM_DEADCHAR:
	    EVENT_PRINTF2(("WM_DEADCHAR %x\n, wParam"));
	    break;

	case WM_PAINTICON:
	    EVENT_PRINTF(("WM_PAINTICON\n"));
	    break;

	case WM_ICONERASEBKGND:
	    EVENT_PRINTF(("WM_ICONERASEBKGND\n"));
	    break;

	case WM_WINDOWPOSCHANGED:
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGED\n"));
	    break;

	case WM_WINDOWPOSCHANGING:
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGING\n"));
	    break;

	case WM_QUERYOPEN:
	    EVENT_PRINTF(("WM_QUERYOPEN\n"));
	    break;

	case WM_QUERYENDSESSION:
	    EVENT_PRINTF(("WM_QUERYENDSESSION\n"));
	    break;

	case WM_FONTCHANGE:
	    EVENT_PRINTF(("WM_FONTCHANGE\n"));
	    break;

	case WM_CAPTURECHANGED:
	    EVENT_PRINTF(("WM_CAPTURECHANGED\n"));
	    break;

	case WM_MOVING:
	    EVENT_PRINTF(("WM_MOVING\n"));
	    break;

	case WM_SYSCOLORCHANGE:
	    EVENT_PRINTF(("WM_SYSCOLORCHANGE\n"));
	    break;

	case WM_KILLFOCUS:
	    EVENT_PRINTF(("WM_KILLFOCUS\n"));
	    break;

	case WM_SIZING:
	    EVENT_PRINTF(("WM_SIZING\n"));
	    __debugEvent__();
	    break;

	default:
	    EVENT_PRINTF(("msg = %x\n", message));
	    break;
    }
    return 0;
}

LONG APIENTRY
MainWndProc(hWnd, message, wParam, lParam) 
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
{
    int wantDefault = 1;
    int retVal;
#ifdef CALLLEVEL_DEBUG
    static int callLevel = 0;
#endif
    extern int __isOnCStack();

#ifdef CALLLEVEL_DEBUG
    DPRINTF(("{%d (%s)\n", callLevel, __isOnCStack()?"C-stack":"")); callLevel++;
#endif

    retVal = winEventProcessing(hWnd, message, wParam, lParam, &wantDefault);
#ifdef EARLY_DEFPROC
    if (wantDefault) {
	DDPRINTF((">>DefWindowProc\n"));
	retVal = DefWindowProc(hWnd, message, wParam, lParam);
	DDPRINTF(("<<DefWindowProc\n"));
    }
#endif

    if (!inSTXEscape) {
        MSG msg;

	/*
	 * reschedule for immediate processing
	 */
	inSTXEscape++;
	while (eventQueueHead
    		 && !GetQueueStatus(QS_ALLINPUT)
		 && (PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE) == 0)) {
	    DDPRINTF(("**** > reschedule\n"));
	    __SSEND0(@global(Display), @symbol(eventQProcessing), 0);
	    DDPRINTF(("**** < back\n"));
	}
	inSTXEscape--;
    }

#ifndef EARLY_DEFPROC
    if (wantDefault) {
	DDPRINTF((">>DefWindowProc\n"));
	retVal = DefWindowProc(hWnd, message, wParam, lParam);
	DDPRINTF(("<<DefWindowProc\n"));
    }
#endif

#ifdef CALLLEVEL_DEBUG
    callLevel--; DPRINTF(("}%d\n", callLevel));
#endif
    DDPRINTF(("<< MainWndProc (%d)\n", retVal));

    return retVal;
}

int CALLBACK
EnumFPTypeFace( lplf, lptm, dwType, lpData )
	LOGFONT*        lplf;
	TEXTMETRIC*     lptm;
	DWORD           dwType;
	LPARAM          lpData;
{
	OBJ t;
	OBJ* refToList;
	OBJ  typeFaceList;

	t = __MKSTRING( lplf->lfFaceName );
	refToList = (OBJ*) lpData;
	typeFaceList = *refToList;
	__SSEND1( typeFaceList, @symbol(add:), 0, t );
	return 1;
}

int CALLBACK 
EnumFontsProc( lplf, lptm, dwType, lpData )
	LOGFONT*      lplf;     /* address of logical-font data */
	TEXTMETRIC*   lptm;     /* address of physical font data */
	DWORD         dwType;   /* font type */
	LPARAM        lpData;   /* address of application supplied data */
{
	OBJ newArray, t;
	OBJ *refToList;
	OBJ list;
	char *s;

	DPRINTF(("EnumFontProc\n\n\n\n"));

	if( lplf ) {
	    DPRINTF((" lfHeight          %d\n", lplf->lfHeight ));
	    DPRINTF((" lfWidth           %d\n", lplf->lfWidth  ));
	    DPRINTF((" lfEscapement      %d\n", lplf->lfEscapement  ));
	    DPRINTF((" lfOrientation     %d\n", lplf->lfOrientation  ));
	    DPRINTF((" lfWeight          %d\n", lplf->lfWeight  ));
	    DPRINTF((" lfItalic          %d\n", lplf->lfItalic  ));
	    DPRINTF((" lfUnderline       %d\n", lplf->lfUnderline  ));
	    DPRINTF((" lfStrikeOut       %d\n", lplf->lfStrikeOut  ));
	    DPRINTF((" lfCharSet         %d\n", lplf->lfCharSet  ));
	    DPRINTF((" lfOutPrecision    %d\n", lplf->lfOutPrecision  ));
	    DPRINTF((" lfClipPrecision   %d\n", lplf->lfClipPrecision  ));
	    DPRINTF((" lfQuality         %d\n", lplf->lfQuality  ));
	    DPRINTF((" lfPitchAndFamily  %d\n", lplf->lfPitchAndFamily  ));
	    DPRINTF((" lfFaceName        %s\n\n", lplf->lfFaceName  ));

	    newArray = __ARRAY_NEW_INT(16);
	    __ArrayInstPtr(newArray)->a_element[0] = __MKSMALLINT(lplf->lfHeight);
	    __ArrayInstPtr(newArray)->a_element[1] = __MKSMALLINT(lplf->lfWidth);
	    __ArrayInstPtr(newArray)->a_element[2] = __MKSMALLINT(lplf->lfEscapement);
	    __ArrayInstPtr(newArray)->a_element[3] = __MKSMALLINT(lplf->lfOrientation);
	    switch (lplf->lfWeight) {
		case FW_NORMAL:
		    s = "normal";
		    break;
		case FW_BOLD:
		    s = "bold";
		    break;
		case FW_MEDIUM:
		    s = "medium";
		    break;
		case FW_LIGHT:
		    s = "demi";
		    break;
		default:
		    s = "other";
		    break;
	    }
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[4] = t; __STORE(newArray, t);

	    if( lplf->lfItalic == TRUE ) {
		if( lplf->lfUnderline == TRUE ) {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "italic-underline-strikeOut";
		    } else {
			s = "italic-underline";
		    }
		} else {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "italic-strikeOut";
		    } else {
			s = "italic";
		    }
		}
	    } else {
		if( lplf->lfUnderline == TRUE ) {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "underline-strikeOut";
		    } else {
			s = "underline";
		    }
		} else {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "strikeOut";
		    } else {
			s = "normal";
		    }
		}
	    }
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[15] = t; __STORE(newArray, t);
                
	    __ArrayInstPtr(newArray)->a_element[5] = __MKSMALLINT(lplf->lfItalic);
	    __ArrayInstPtr(newArray)->a_element[6] = __MKSMALLINT(lplf->lfUnderline);
	    __ArrayInstPtr(newArray)->a_element[7] = __MKSMALLINT(lplf->lfStrikeOut);
	    __ArrayInstPtr(newArray)->a_element[8] = __MKSMALLINT(lplf->lfCharSet);
	    __ArrayInstPtr(newArray)->a_element[9] = __MKSMALLINT(lplf->lfOutPrecision);
	    __ArrayInstPtr(newArray)->a_element[10] = __MKSMALLINT(lplf->lfClipPrecision);
	    __ArrayInstPtr(newArray)->a_element[11] = __MKSMALLINT(lplf->lfQuality);
	    __ArrayInstPtr(newArray)->a_element[12] = __MKSMALLINT(lplf->lfPitchAndFamily);
	    /* ... */
	    __PROTECT__(newArray);
	    t = __MKSTRING(lplf->lfFaceName);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[13] = t; __STORE(newArray, t);

	    if( dwType == DEVICE_FONTTYPE ) 
		s = "device";
	    else if( dwType == RASTER_FONTTYPE )
		s = "raster";
	    else if( dwType == TRUETYPE_FONTTYPE )
		s = "typetype";
	    else
		s = "unknown";
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
            
	    __ArrayInstPtr(newArray)->a_element[14] = t; __STORE(newArray, t);

	    refToList = (OBJ*) lpData;
	    list = *refToList;
	    __SSEND1(list, @symbol(add:), 0, newArray);
	}

	DPRINTF((" dwType            %d\n", dwType ));
	return 1;
}

%}
! !


!WinWorkstation  class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    See more documentation in my superclass, DeviceWorkstation.

    [author:]
	Claus Gittinger
"
! !

!WinWorkstation class methodsFor:'initialization'!

initialize
    |d nButtons swap|

    super initialize.

    NativeWindows := false.

    BeepFrequency := 440.       "/ Hertz
    BeepDuration := 200.        "/ millis

    RawKeysymTranslation := d := Dictionary new.
    d at:'Right Alt'     put:#'Alt_R'.
    d at:'Left Alt'      put:#'Alt_L'.
    d at:'Right Shift'   put:#'Shift_R'.
    d at:'Left Shift'    put:#'Shift_L'.
    d at:'Right Control' put:#'Ctrl_R'.
    d at:'Left Control'  put:#'Ctrl_L'.
    d at:'Control'       put:#'Ctrl'.

    d at:'Backspace'     put:#'BackSpace'.
    d at:'Up'            put:#'CursorUp'.
    d at:'Down'          put:#'CursorDown'.
    d at:'Right'         put:#'CursorRight'.
    d at:'Left'          put:#'CursorLeft'.
    d at:'Page Up'       put:#'PreviousPage'.
    d at:'Page Down'     put:#'NextPage'.
    d at:'Prnt Scrn'     put:#'Print'.

    ButtonTranslation := #(1 2 2).

    nButtons := self getSystemMetrics:#mouseButtons.
    swap := self getSystemMetrics:#swapButton.

    nButtons == 0 ifTrue:[
	'WinWorkstation [warning]: mouse-less operation may not work' infoPrintCR.
    ] ifFalse:[
	nButtons == 2 ifTrue:[
	    ButtonTranslation := #(1 2).
	].
	swap ifTrue:[
	    ButtonTranslation := ButtonTranslation copy reverse
	]
    ].

    "/ translation table from ST/X windowType symbol (system-independent)
    "/ to Windows windowClass (windows-specific).
 
    NativeWindowClassTable := IdentityDictionary new.
    NativeWindowClassTable at:#ScrollBar     put:'SCROLLBAR'.
    NativeWindowClassTable at:#CheckBox      put:'BUTTON'.
    NativeWindowClassTable at:#RadioButton   put:'BUTTON'.
    NativeWindowClassTable at:#Button        put:'BUTTON'.
    NativeWindowClassTable at:#DefaultButton put:'BUTTON'.
    NativeWindowClassTable at:#ComboBox      put:'COMBOBOX'.
    NativeWindowClassTable at:#EditField     put:'EDIT'.
    NativeWindowClassTable at:#ListBox       put:'LISTBOX'.
!

nativeWindows:aBoolean
    "enable / disable use of native windows"

    NativeWindows := aBoolean
! !

!WinWorkstation class methodsFor:'error handling'!

debug:aBoolean
%{  /* NOCONTEXT */

    __debug__ = (aBoolean == true) ? 1 : 0;
%}
! !

!WinWorkstation class methodsFor:'queries'!

platformName
    "ST-80 compatibility.
     Return a string describing the display systems platform."

    ^ 'WIN32'  

    "Modified: 26.5.1996 / 15:32:46 / cg"
!

getSystemMetrics:aSymbol
%{
    int info = 0;
    int isBool = 0;
    int arg;

    if (aSymbol == @symbol(swapButton)) {
	arg = SM_SWAPBUTTON;
	isBool = 1;
    } else if (aSymbol == @symbol(mouseButtons)) {
	arg = SM_CMOUSEBUTTONS;
    } else if (aSymbol == @symbol(iconWidth)) {
	arg = SM_CXICON;
    } else if (aSymbol == @symbol(iconHeight)) {
	arg = SM_CYICON;
    } else if (aSymbol == @symbol(cursorWidth)) {
	arg = SM_CXCURSOR;
    } else if (aSymbol == @symbol(cursorHeight)) {
	arg = SM_CYCURSOR;
    } else if (aSymbol == @symbol(captionHeight)) {
	arg = SM_CYCAPTION;
    } else if (aSymbol == @symbol(resizeFrameWidth)) {
	arg = SM_CXFRAME;
    } else if (aSymbol == @symbol(resizeFrameHeight)) {
	arg = SM_CYFRAME;
    } else if (aSymbol == @symbol(borderFrameWidth)) {
	arg = SM_CXBORDER;
    } else if (aSymbol == @symbol(borderFrameHeight)) {
	arg = SM_CYBORDER;
    } else if (aSymbol == @symbol(fullScreenWindowWidth)) {
	arg = SM_CXFULLSCREEN;
    } else if (aSymbol == @symbol(fullScreenWindowHeight)) {
	arg = SM_CYFULLSCREEN;
    } else {
	RETURN (nil);
    }
    info = GetSystemMetrics(arg);
    if (isBool) {
	RETURN (info ? true : false);
    }
    RETURN (__MKSMALLINT(info));
%}
! !

!WinWorkstation methodsFor:'special Windows brain damage workaround'!

eventQProcessing
    "since DefWindowProc stays in an internal loop (recursively calling
     our windowProc), escape here, processing any queued win-event and giving 
     other processes a chance to run"

    inRecursiveDispatch := true.
    [self eventQueuedAlready] whileTrue:[
	self dispatchLastEvent
    ].
    inRecursiveDispatch := false.
    Delay waitForMilliseconds:20
! !

!WinWorkstation methodsFor:'accessing & queries'!

anyButtonMotionMask
    "return the state-mask for any button in motion events' state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(Button1MotionMask | Button2MotionMask | Button3MotionMask)); 
%}
!

blackpixel
    "return the colornumber of black"

    ^ blackpixel
!

button1MotionMask
    "return the state-mask for button1 in motion events' state-field.
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button1MotionMask)); 
%}

    "
     Display button1MotionMask
    "
!

button2MotionMask
    "return the state-mask for button2 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button2MotionMask)); 
%}
!

button3MotionMask
    "return the state-mask for button3 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button3MotionMask)); 
%}
!

buttonMotionMask:aButton
    "return the state-mask for button1 in motion events state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    if (aButton == __MKSMALLINT(1)) {
	RETURN (__MKSMALLINT(Button1MotionMask));    
    }
    if (aButton == __MKSMALLINT(2)) {
	RETURN (__MKSMALLINT(Button2MotionMask));    
    }
    if (aButton == __MKSMALLINT(3)) {
	RETURN (__MKSMALLINT(Button3MotionMask));    
    }
%}.
    ^ nil
!

controlMask
    "return the state-mask for the CTRL modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ControlMask));
%}
!

defaultEventMask
    "return a mask to enable some events by default."

%{  /* NOCONTEXT */
#ifdef XXX
    RETURN (__MKSMALLINT(ExposureMask | StructureNotifyMask |
			 KeyPressMask | KeyReleaseMask |
			 EnterWindowMask | LeaveWindowMask |
			 ButtonPressMask | ButtonMotionMask | ButtonReleaseMask ));
#endif
%}.
    ^ 0
!

displayFileDescriptor
    "return the displays fileNumber for select, if any"

%{  /* NOCONTEXT */
    RETURN (nil);
%}
!

displayName
    "return the display-connections display name.
     For Windows, a dummy name is returned"

    ^ 'local'
!

getSystemColor:aKey
    |rgb|

%{
    if (aKey == @symbol(COLOR_WINDOW)) {
	rgb = __MKSMALLINT(GetSysColor(COLOR_WINDOW));
    }
    if (aKey == @symbol(COLOR_WINDOWTEXT)) {
	rgb = __MKSMALLINT(GetSysColor(COLOR_WINDOWTEXT));
    }
    if (aKey == @symbol(COLOR_MENU)) {
	rgb = __MKSMALLINT(GetSysColor(COLOR_MENU));
    }
    if (aKey == @symbol(COLOR_MENUTEXT)) {
	rgb = __MKSMALLINT(GetSysColor(COLOR_MENUTEXT));
    }
%}.
    rgb notNil ifTrue:[
	^ Color 
	    redByte:((rgb bitShift:-16) bitAnd:16rFF)
	    greenByte:((rgb bitShift:-8) bitAnd:16rFF)
	    blueByte:(rgb bitAnd:16rFF)
    ].
    ^ nil
!

protocolVersion
    "return the displays protocol version. 
     For Windows, a dummy number is returned"

    ^ '1'

    "
     Display protocolVersion
    "
!

serverVendor
    "return the server vendor string. 
     For Windows, a dummy name is returned"

    ^ 'microsoft'

    "
     Display serverVendor
    "
!

shiftMask
    "return the state-mask for the SHIFT modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ShiftMask));
%}
!

translatePoint:aPoint from:windowId1 to:windowId2
    "given a point in window1, return the coordinate in window2.
     This expects a device coordinate (relative to the first views origin)
     in aPoint and returns a device coordinate relative to the 2nd views origin.
     - use to xlate points from a window to rootwindow"

    |x1 y1 x2 y2|

    x1 := x2 := aPoint x truncated.
    y1 := y2 := aPoint y truncated.
%{
    int xpos, ypos;
    HWND w1, w2;
    RECT srcRect, dstRect;

    if (__isExternalAddress(windowId1)
     && __isExternalAddress(windowId2)
     && __bothSmallInteger(x1, y1)) {
	w1 = _HWNDVal(windowId1);
	w2 = _HWNDVal(windowId2);

	GetWindowRect(w1, &srcRect);
	GetWindowRect(w2, &dstRect);

	DDPRINTF(("srcRect: %d/%d -> %d/%d   dstRect: %d/%d -> %d/%d\n",
	    srcRect.left, srcRect.top, srcRect.right, srcRect.bottom,
	    dstRect.left, dstRect.top, dstRect.right, dstRect.bottom));

	xpos = srcRect.left - dstRect.left + __intVal(x1);
	ypos = srcRect.top - dstRect.top + __intVal(y1);

	x2 = __MKSMALLINT(xpos);
	y2 = __MKSMALLINT(ypos);
    }
%}.
"/ 'translated ' print. aPoint print. ' from ' print. windowId1 address print.
"/' -> ' print. (x2@y2) print. ' in ' print. windowId2 address printCR.

    ^ (x2 @ y2)
!

vendorRelease
    "return the display-servers vendor release 
     - should normally not be of any interest, 
     but may be usefule for special cases.
     (to avoid bugs in certain implementations / releases)"

    ^ 1

    "
     Display vendorRelease
    "
!

whitepixel
    "return the colornumber of white"

    ^ whitepixel
! !

!WinWorkstation methodsFor:'accessing display capabilities'!

iconSizes
    "Get the preferred/supported icon sizes."

    |d|

    d := IdentityDictionary new.
    d at:#minWidth put:32.
    d at:#maxWidth put:32.
    d at:#widthStep put:1.
    d at:#minHeight put:32.
    d at:#maxHeight put:32.
    d at:#heightStep put:1.

    ^ OrderedCollection with:d

    "
     Display iconSizes
    "
!

supportsIconViews
    "return true, if this device supports views as icons."

    ^ true

    "
     Display supportsIconViews 
    "

    "Modified: 10.6.1996 / 20:11:48 / cg"
    "Created: 10.6.1996 / 21:08:18 / cg"
!

usableExtent
    "return the usable extent of the display (in pixels).
     Normally, the same as extent, but may be smaller, in
     case some menu space is taken up by the window manager (windows)"

    ^ (self class getSystemMetrics:#fullScreenWindowWidth)
      @
      (self class getSystemMetrics:#fullScreenWindowHeight)
! !

!WinWorkstation methodsFor:'bitmap/window creation'!

createBitmapFromArray:anArray width:w height:h
    |bitmapId|

    bitmapId := self primCreateBitmapFromArray:anArray width:w height:h.

    bitmapId isNil ifTrue:[
	'WINWORKSTATION: cannot create bitmap' errorPrintCR.
    ].
    ^ bitmapId
!

createBitmapWidth:w height:h
    "allocate a bitmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */
    HANDLE newBitmapHandle;
    int b_width, b_height;

    if (__bothSmallInteger(w, h)) {
	b_width = __intVal(w);
	b_height = __intVal(h);
	newBitmapHandle = CreateBitmap(b_width, b_height, 1, 1, NULL);

	if( newBitmapHandle )
	{
	    if( SetBitmapDimensionEx( newBitmapHandle, b_width, b_height, NULL ) )
	    {
		DPRINTF(("SIZE SET!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d\n", 
				newBitmapHandle, b_height, b_width ));
	    }
	    else
	    {
		DPRINTF(("ERROR in setting Size!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d\n", 
				newBitmapHandle, b_height, b_width ));
	    }
	}
#ifdef COUNT_RESOURCES
	if (newBitmapHandle)
	    __cnt_bitmap++;
#endif
	DPRINTF(("empty bitmap handle = %x\n", newBitmapHandle));

	RETURN ( (newBitmapHandle != NULL) ? __MKOBJ(newBitmapHandle) : nil );
    }
%}.
    "/ invalid (non-smallInteger) arguments

    self primitiveFailed.
    ^ nil
!

createPixmapWidth:w height:h depth:d
    "allocate a pixmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */

    HANDLE newBitmapHandle;
 
    if (__bothSmallInteger(w, h) && ISCONNECTED) {
	newBitmapHandle = CreateBitmap(__intVal(w), __intVal(h), 1, 8, NULL );
	if( newBitmapHandle )
	{
	    if( SetBitmapDimensionEx( newBitmapHandle, __intVal(w), __intVal(h), NULL ) )
	    {
		DPRINTF(("SIZE SET!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d\n", 
				newBitmapHandle, __intVal(h), __intVal(w) ));
	    }
	    else
	    {
		DPRINTF(("ERROR in setting Size!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d\n", 
				newBitmapHandle, __intVal(h), __intVal(w) ));
	    }
	}
#ifdef COUNT_RESOURCES
	if (newBitmapHandle)
	    __cnt_bitmap++;
#endif
	RETURN ( (newBitmapHandle != NULL) ? __MKOBJ(newBitmapHandle) : nil );
    }

%}.
    ^ nil
!

createWindowFor:aView type:typeSymbol
		 origin:origin
		 extent:extent
		 minExtent:minExt 
		 maxExtent:maxExt
		 borderWidth:bWidth
		 subViewOf:wsuperView
		 style:wStyle
		 inputOnly:winputOnly
		 label:wlabel
		 cursor:wcursor
		 icon:wicon 
		 iconMask:wiconMask
		 iconView:wiconView

    |xpos ypos wwidth wheight minWidth minHeight maxWidth maxHeight 
     bColorId wsuperViewId wcursorId wiconId wiconMaskId windowId
     weventMask wiconViewId bitGravity viewGravity vBgColor
     vBgForm deepForm preferredVisual preferredDepth wiconHeight 
     wiconWidth windowType windowClass|

    displayId isNil ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    origin notNil ifTrue:[
	xpos := origin x.
	ypos := origin y.
    ] ifFalse:[
	xpos := ypos := 0.
    ].
    extent notNil ifTrue:[
	wwidth := extent x.
	wheight := extent y.
    ] ifFalse:[
	wwidth := wheight := 100.
    ].
    minExt notNil ifTrue:[
	minWidth := minExt x.
	minHeight := minExt y
    ].
    maxExt notNil ifTrue:[
	maxWidth := maxExt x.
	maxHeight := maxExt y
    ].

    wsuperView notNil ifTrue:[
	wsuperViewId := wsuperView id
    ].
    wcursor isNil ifTrue:[
	'XWORKSTATION: cursor nil - defaulted' errorPrintNL
    ] ifFalse:[
	wcursorId := wcursor id
    ].

    wicon notNil ifTrue:[
	wiconId := wicon id.
	wiconHeight := wicon height.
	wiconWidth  := wicon width.
	wiconMask notNil ifTrue:[
	    wiconMaskId := wiconMask id
	]
    ].
    wiconView notNil ifTrue:[
	wiconViewId := wiconView id
    ].
    weventMask := aView eventMask.

    NativeWindows ifTrue:[
	windowType := aView nativeWindowType.

	"/ if it is already a string, take it as it is;
	"/ otherwise, it must be a symbol and is used
	"/ as a key into the nativeClass translation map.

	windowType isString ifTrue:[
	    windowClass := windowType
	] ifFalse:[
	    windowClass := NativeWindowClassTable at:windowType ifAbsent:nil
	]
    ].

%{  /* STACK:16000 */
    extern void *__getHInstance(), *__getHPrevInstance();

    WNDCLASS wc;
    long bg, bd, bw;
    int winStyleBits, winEXStyleBits;
    int w, h, x, y;
    int ncW, ncH;
    int min_width, min_height;
    int max_width, max_height;
    HANDLE parentHandle;
    HANDLE newWinHandle;
    char *windowName = NULL;
    int isTopWindow = 0;

    unsigned char* cp;
    unsigned char* ep;
    HBITMAP        xBitMap, maskBitmap;
    int            height, width;
    int            nBytes, nBits;
    int            index;
    HICON          xIcon = (HICON)0;
    HICON          yIcon = (HICON)0;
    SIZE           oldSize;
    ICONINFO       iconInfo;
    char *className;

    bg = WhitePixel;
    bd = BlackPixel;

    /* get bitmap for icon */
    if(  __isExternalAddress(wiconId) ) {
	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 ) {
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 15 ) / 16;
	    nBytes = height * 2 * nBytes;
	    ep = (unsigned char *) malloc(nBytes);
	    if( ep != 0 ) {
		for( index = 0; index < nBytes; index++ ) {
		    *ep++ = 0x00;
		}
		maskBitmap = CreateBitmap(width, height, 1, 1, ep );
		if( maskBitmap != NULL ) {
		    DPRINTF(( "BITMAP mask CREATED!!!\n" ));
		    iconInfo.fIcon = TRUE; 
		    iconInfo.hbmMask  = maskBitmap;
		    iconInfo.hbmColor = xBitMap;
		    xIcon = CreateIconIndirect( &iconInfo );
		    DPRINTF(( "ICON CREATED!!!\n" ));
		    DeleteObject( maskBitmap );
		} else {
		    DPRINTF(( "BITMAP mask CREATION failed!!!\n" ));
		}
	    } else {
		DPRINTF(( " malloc failed\n" ));
	    }
	} else {
	    DPRINTF((" xBitMap is zero \n" ));
	}
    } else {
	if (wiconId == nil) {
	    DPRINTF((" wiconId is nil\n"));
	} else {
	    DPRINTF((" wiconId is not an external address\n"));
	}
    }

#if 0
    /* get bitmap for icon */
    if(  __isExternalAddress(wiconId) ) {
	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 ) {
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 15 ) / 16;
	    nBytes = height * 2 * nBytes;
	    if( GetBitmapDimensionEx( xBitMap, &oldSize ) ) {
		DPRINTF(( "%d SIZES x: %d y: %d height: %d width: %d nBytes: %d\n", 
				xBitMap, oldSize.cx, oldSize.cy, height, width, nBytes ));
	    } else {
		DPRINTF(( "GetBitmapDimensionEx FAILED!!!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d nBytes: %d\n", 
				xBitMap, height, width, nBytes )) ;
	    }
	    if( nBytes != 0 ) {
		cp = (unsigned char *) malloc(nBytes);
		ep = (unsigned char *) malloc(nBytes);
		if( ( cp != 0 ) && ( ep != 0 ) ) {
		    nBits = 0;
		    nBits = GetBitmapBits( xBitMap, nBytes, cp );
		    if( nBits != 0 ) {
			DPRINTF(( "Bitmap Bits retrieved size: %d!\n", nBits ));
		    } else {
			DPRINTF(( "NO bitmap!\n" ));
		    }
		    for( index = 0; index < nBytes; index++ ) {
			*ep++ = 0x00;
		    }
		    DPRINTF(( "MOMORY CLEARED for ep\n" ));
		    xIcon = CreateIcon( (HANDLE) __getHInstance(),
					width,
					height,
					1,
					1,
					ep,
					cp );
		    DPRINTF(( "ICON CREATED!!!\n" ));
		} else {
		    DPRINTF(( " malloc failed\n" ));
		}
	    } else {
		DPRINTF(( " nBytes is zero \n" ));
	    }
	} else {
	    DPRINTF((" xBitMap is zero \n" ));
	}
    } else {
	if (wiconId == nil) {
	    DPRINTF((" wiconId is nil\n"));
	} else {
	    DPRINTF((" wiconId is not an external address\n"));
	}
    }
    DPRINTF(("It seems that the ICON was created\n" ));
#endif

    if (firstInstance) {
	DPRINTF(("first create - registerClass\n"));

	hInstance = (HANDLE) __getHInstance();
	hPrevInstance = (HANDLE) __getHPrevInstance();

	wc.style = /* CS_HREDRAW | CS_VREDRAW |*/ CS_OWNDC | CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC) MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	if (xIcon) {
		wc.hIcon   = xIcon;
		/* wc.hIconSm = wiconId; In 4.x there are large and small icons */
	} else {        
		wc.hIcon = NULL;        /* THIS MUST BE NULL TO DELETE ICONS */
	}
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);

	wc.hbrBackground = CreateSolidBrush (bg);

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = app_name;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}
/* MOVED TO AFTER SETTING THE ICON 
	firstInstance = 0;
*/
    }

    if (__bothSmallInteger(wwidth, wheight)) {
	w = __intVal(wwidth);
	h = __intVal(wheight);
    } else {
	w = h = 100;
    }

    if (__bothSmallInteger(xpos, ypos)) {
	x = __intVal(xpos);
	y = __intVal(ypos);
    } else {
	x = y = 0;
    }

    if (__bothSmallInteger(minWidth, minHeight)) {
	min_width = __intVal(minWidth);
	min_height = __intVal(minHeight);
    } else {
	min_width = min_height = 0;
    }

    if (__bothSmallInteger(maxWidth, maxHeight)) {
	max_width = __intVal(maxWidth);
	max_height = __intVal(maxHeight);
    } else {
	max_width = max_height = 10000;
    }

    winStyleBits = winEXStyleBits = 0;

    if (__isSmallInteger(bWidth)) {
	bw = __intVal(bWidth);
	if (bw) {
	    winStyleBits |= WS_BORDER;
	    bw = 1;
	}
    } else {
	bw = 0;
    }

    className = app_name;

    if (__isString(windowClass)) {
	className = __stringVal(windowClass);
    }

    if (__isString(windowClass)) {
	if (__isInteger(wStyle)) {
	    winStyleBits |= __longIntVal(wStyle);
	} else {
	    if (windowType == @symbol(RadioButton)) {
		winStyleBits |= BS_RADIOBUTTON;
	    } else if (windowType == @symbol(CheckBox)) {
		winStyleBits |= BS_CHECKBOX;
	    } else if (windowType == @symbol(HorizontalScrollbar)) {
		winStyleBits |= SBS_HORZ;
	    } else if (windowType == @symbol(VerticalScrollBar)) {
		winStyleBits |= SBS_VERT;
	    }
	}
    }

    if (__isExternalAddress(wsuperViewId)) {
	/* 
	 * a child window
	 */
	parentHandle = _HANDLEVal(wsuperViewId);
	winStyleBits |= WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	DPRINTF(("parent handle=%x\n", parentHandle));

	create_topView = 0;
	ncW = bw * 2;
	ncH = bw * 2;
    } else {
	/* 
	 * a top window
	 */
	parentHandle = NULL;
	isTopWindow = 1;
	DPRINTF(("topview\n"));

	create_topView = 1;
	create_minWidth = min_width;
	create_maxWidth = max_width;
	create_minHeight = min_height;
	create_maxHeight = max_height;

	winStyleBits |= WS_CLIPCHILDREN;

	if (wStyle == @symbol(popUp)) {
	    winStyleBits |= WS_POPUP;
	    ncW = bw * 2;
	    ncH = bw * 2;
	} else if (wStyle == @symbol(dialog)) {
/*
	    winStyleBits |= WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME;
*/
	    winStyleBits |= WS_OVERLAPPED | WS_CAPTION | DS_MODALFRAME | WS_SYSMENU;
	    ncW = __intVal(__INST(resizeFrameWidth)) * 2;
	    ncH = __intVal(__INST(resizeFrameHeight)) + __intVal(__INST(captionHeight));
	    if ((min_width || min_height) 
	     && (min_width == max_width)
	     && (min_height == max_height)) {
		winStyleBits &= ~WS_THICKFRAME;
	    }
	} else {
	    winStyleBits |= WS_OVERLAPPEDWINDOW;
	    winEXStyleBits |= WS_EX_CLIENTEDGE;

	    ncW = __intVal(__INST(resizeFrameWidth)) * 2;
	    ncH = __intVal(__INST(resizeFrameHeight)) + __intVal(__INST(captionHeight));
/*            ncH = 32 + 4 + 4; /* __intVal(__INST(resizeFrameHeight)) */;
	}
    }

    DPRINTF(("create%s pos==%d/%d size=%d/%d bw=%d class='%s'...\n", 
		((wStyle == @symbol(popUp)) ? " popUp" : ""), x, y, w, h, bw, className));

    inCreate = 1;
    newWinHandle = CreateWindowEx(
				WS_EX_LEFT | WS_EX_NOPARENTNOTIFY ,
				className, 
				"",             /* window name */
				winStyleBits,
				x, y,
				w + ncW, h + ncH,
				parentHandle,
				NULL,           /* menu */
				hInstance, 
				NULL);
    inCreate = 0;

    DPRINTF(("handle = %x\n", newWinHandle));

    if (! newWinHandle) {
	RETURN ( nil );
    }

    /*
     * define its icon and name
     * (only makes sense for topWindows)
     */
    if (isTopWindow) {
	if (__isString(wlabel) || __isSymbol(wlabel)) {
	    windowName = (char *) __stringVal(wlabel);
	    DPRINTF(("title = %s\n", windowName));
	    (void) SetWindowText(newWinHandle, windowName);
	}
    }

    if (! firstInstance) {
	if (xIcon) {
#if 0
	    DPRINTF(("not first create - erase icon background\n")); 
	    DefWindowProc( newWinHandle, WM_ICONERASEBKGND, NULL, NULL );
#endif
	    DPRINTF(("not first create - set icon\n"));
#if 0
	    yIcon = (HICON) DefWindowProc( newWinHandle, WM_SETICON, ICON_BIG, (long) xIcon );
#endif
	    Static_SetIcon(newWinHandle, xIcon);
	}
    } else {
	firstInstance = 0;
    }

    windowId = __MKOBJ(newWinHandle);
    DPRINTF(("done - create\n"));
%}.
    self addKnownView:aView withId:windowId.
    ^ windowId
!

destroyGC:aGCId
%{
    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);

	if (gcData->hDC) {
	    DeleteDC(gcData->hDC);
	    gcData->hDC = (HDC)0;
	}
	if (gcData->hPen) {
	    DeleteObject(gcData->hPen);
	    gcData->hPen = (HPEN)0;
	}
	if (gcData->hBrush) {
	    DeleteObject(gcData->hBrush);
	    gcData->hBrush = (HPEN)0;
	}
	if (gcData->clipRgn) {
	    DeleteObject(gcData->clipRgn);
	    gcData->clipRgn = (HRGN)0;
	}
	free(gcData);
    }
%}.
    ^ self
!

destroyPixmap:aDrawableId
%{
    if (__isExternalAddress(aDrawableId) && ISCONNECTED) {
	HANDLE bitmapHandle = _HANDLEVal(aDrawableId);

	if (bitmapHandle) {
	    if( DeleteObject(bitmapHandle) )
	    {
		DPRINTF(("Bitmap deleted!\n"));
#ifdef COUNT_RESOURCES
		__cnt_bitmap--;
#endif
	    }
	}
	RETURN ( self );
    }
%}.
    "/ invalid argument or not yet opened
    self primitiveFailed
!

destroyView:aView withId:aWindowId
%{
    HICON yIcon;

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
#if 0
	    yIcon = (HICON) DefWindowProc( win, WM_GETICON, ICON_BIG, 0 );
#endif
	    yIcon = Static_GetIcon(win);
	    Static_SetIcon(win, 0);

	    if( yIcon ) {
		if( DestroyIcon( yIcon ) )
		    DPRINTF(("Icon for window deleted!\n"));
	    }
	    DestroyWindow(win);
	}
    }
%}.
    self removeKnownView:aView withId:aWindowId
!

gcFor:aDrawableId

%{  /* NOCONTEXT */
    HDC dc;
    struct gcData *gcData;

    if (__isExternalAddress(aDrawableId)) {
	dc = GetDC(_HWNDVal(aDrawableId));
	if (! dc) {
	    RETURN (nil);
	}
	gcData = (struct gcData *)malloc(sizeof(struct gcData));
	if (! gcData) {
	    RETURN (nil);
	}
	gcData->hDC = dc;
	gcData->hPen = (HPEN)0;
	gcData->hBrush = (HBRUSH)0;
	gcData->fgColor = (COLORREF)0;
	gcData->bgColor = (COLORREF)0;
	gcData->brushType = BR_SOLID;
	gcData->lineWidth = 1;
	gcData->lineStyle = PS_SOLID;
	gcData->joinStyle = PS_JOIN_MITER;
	gcData->capStyle = PS_ENDCAP_FLAT;
	gcData->clipRgn = (HRGN)0;

	RETURN ( __MKOBJ(gcData) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

gcForBitmap:aDrawableId
%{  /* NOCONTEXT */
    HDC dc;
    HDC rootDC;
    struct gcData *gcData;

    if (__isExternalAddress(aDrawableId)) {
	rootDC = __rootDC;
	dc = CreateCompatibleDC(rootDC);
	if (! dc) {
	    RETURN (nil);
	}
	gcData = (struct gcData *)malloc(sizeof(struct gcData));
	if (! gcData) {
	    RETURN (nil);
	}
	gcData->hDC = dc;
	gcData->hPen = (HPEN)0;
	gcData->hBrush = (HBRUSH)0;
	gcData->fgColor = (COLORREF)0;
	gcData->bgColor = (COLORREF)0;
	gcData->brushType = BR_SOLID;
	gcData->lineWidth = 1;
	gcData->lineStyle = PS_SOLID;
	gcData->joinStyle = PS_JOIN_MITER;
	gcData->capStyle = PS_ENDCAP_FLAT;
	gcData->clipRgn = (HRGN)0;

	RETURN ( __MKOBJ(gcData) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

primCreateBitmapFromArray:anArray width:w height:h

%{  /* UNLIMITEDSTACK */

    HBITMAP newBitmapHandle;
    unsigned char fastBits[10000];
    int b_width, b_height, bytesPerRowST, bytesPerRowWN, padding, nBytes;
    int row, col;
    unsigned char *cp, *bPits;
    unsigned char *b_bits, *allocatedBits;
    unsigned char *pBits;
    int index;
/*
    if (! ISCONNECTED) {
	RETURN (nil);
    }
*/
    if (__bothSmallInteger(w, h) && _isNonNilObject(anArray)) {
	b_width = __intVal(w);
	b_height = __intVal(h);
	bytesPerRowST = (b_width + 7) / 8;
	bytesPerRowWN = (b_width + 15) / 16 * 2;
	padding = bytesPerRowWN - bytesPerRowST;
	nBytes = b_height * bytesPerRowWN;

	if (nBytes < sizeof(fastBits)) {
	    cp = b_bits = fastBits;
	    allocatedBits = 0;
	} else {
	    cp = b_bits = allocatedBits = (unsigned char *) malloc(nBytes);
	    if (! cp) goto fail;
	}


	if (__qClass(anArray) == @global(Array)) {
DPRINTF(("Array not supported\n"));
	    goto fail;
	} else {
	    if (__qClass(anArray) == @global(ByteArray)) {
		pBits = __ByteArrayInstPtr(anArray)->ba_element;
		for (row = b_height; row; row--) {
		    for (col = bytesPerRowST; col; col--) { 
			*cp++ = ( *pBits++ ^ 0xFF );
		    }
		    cp += padding; 
		}
	    } else {
DPRINTF(("not a ByteArray\n"));
		goto fail;
	    }
	}

	DPRINTF(("create bitmap ...\n"));

	newBitmapHandle = CreateBitmap(b_width, b_height, 1, 1, b_bits );

	if( newBitmapHandle )
	{
	    if( SetBitmapDimensionEx( newBitmapHandle, b_width, b_height, NULL ) )
	    {
		DPRINTF(("SIZE SET!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d nBytes: %d\n", 
				newBitmapHandle, b_height, b_width, nBytes ));
	    }
	    else
	    {
		DPRINTF(("ERROR in setting Size!\n"));
		DPRINTF(( "%d SIZES height: %d width: %d nBytes: %d\n", 
				newBitmapHandle, b_height, b_width, nBytes ));
	    }
	}
	if( newBitmapHandle == NULL ) DPRINTF(("create bitmap FAILED!!!\n"));
fail: ;
	if (allocatedBits) {
	    DPRINTF(("freeing up bitmap bits ...\n"));
	    free(allocatedBits);
	}

	DPRINTF(("returning bitmap ...\n"));
	RETURN ( (newBitmapHandle != NULL) ? __MKOBJ(newBitmapHandle) : nil );
    }
    DPRINTF(("returning nil ...\n"));
    RETURN ( nil );
%}
!

rootWindowId
    "return the id of the root window.
     This is the window you see as background, 
     however, it may or may not be the real physical root window,
     since some window managers install a virtual root window on top
     of the real one. If this is the case, that views id is returned here."

    ^ rootWin
! !

!WinWorkstation methodsFor:'color stuff'!

colorRed:redVal green:greenVal blue:blueVal
    "allocate a color with rgb values (0..100) - return the color index (i.e. colorID).
     This method is obsoleted by #colorScaledRed:scaledGreen:scaledBlue:"

    |r g b|

    r := self percentToDeviceColorValue:redVal.
    g := self percentToDeviceColorValue:greenVal.
    b := self percentToDeviceColorValue:blueVal.
    ^ self colorScaledRed:r scaledGreen:g scaledBlue:b
!

colorScaledRed:r scaledGreen:g scaledBlue:b
    "allocate a color with rgb values (0..16rFFFF) - return the color index 
     (i.e. colorID)"
%{
    int id, ir, ig, ib;

    if (__bothSmallInteger(r, g) 
     && __isSmallInteger(b)) {
	ir = __intVal(r) >> 8;
	ig = __intVal(g) >> 8;
	ib = __intVal(b) >> 8;

	id = RGB ( ir, ig, ib);
	DDPRINTF(("alloc color %d/%d/%d -> %x\n", ir, ig, ib, id));
	RETURN ( __MKSMALLINT(id) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

freeColor:colorIndex
    "free a display color when its no longer needed"

    ^ self
!

getRGBFrom:index into:aBlock
    "get rgb components (0..100) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |val|

    self getScaledRGBFrom:index into:[:r :g :b |
	val := aBlock 
		value:(r * 100.0 / 16rFFFF)
		value:(g * 100.0 / 16rFFFF)
		value:(b * 100.0 / 16rFFFF)
    ].
    ^ val
!

getScaledRGBFrom:index into:aBlock
    "get rgb components (0 .. 16rFFFF) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |r g b|
%{
    int id = __intVal(index);
    int iR, iG, iB;

    if (__INST(usingSystemPalette) == true) {
	r = g = b = __MKSMALLINT(0);
    } else {
	iR = id & 0xFF;
	iG = (id >> 8) & 0xFF;
	iB = (id >> 16) & 0xFF;
	iR = (iR << 8) | iR;
	iG = (iG << 8) | iG;
	iB = (iB << 8) | iB;

	r = __MKSMALLINT(iR);
	g = __MKSMALLINT(iG);
	b = __MKSMALLINT(iB);
    }
%}.
    ^ aBlock value:r value:g value:b
!

percentToDeviceColorValue:aPercentage
    "given a color-component value in percent (0..100), return the corresponding
     WIN-component value (0..16rFFFF) as an integer"

%{  /* NOCONTEXT */

    if (__isSmallInteger(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * __intVal(aPercentage) / 100) );
    }
    if (__isFloat(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * (int)(__floatVal(aPercentage)) / 100) );
    }
%}.
    ^ (16rFFFF * aPercentage / 100) rounded
! !

!WinWorkstation methodsFor:'cursor stuff'!

builtInCursorShapes
    "return a collection of standard cursor names.
     Those are built into Windows and need not be created as
     user cursors.
     (actually, there are more than those below ...)"

    "/ if you add something here, also add to #shapeNumberFromCursor ...

    ^ #(
        #upLeftArrow            "/ IDC_ARROW
        #upDownArrow            "/ IDC_SIZENS
        #leftRightArrow         "/ IDC_SIZEWE
        #text                   "/ IDC_IBEAM         
        #wait			"/ IDC_WAIT   
        #crossHair		"/ IDC_CROSS   
        #fourWay		"/ IDC_SIZE   
       )
!

createCursorShape:aShape
    "create a cursor given a shape-symbol"

    |number id|

    number := self shapeNumberFromSymbol:aShape.
%{
    HCURSOR newCursor;
    LPCTSTR cId;

    if (__isSmallInteger(number)) {
	cId = (LPCTSTR)(__intVal(number));
	newCursor = LoadCursor(NULL, cId);
	if (newCursor) {
#ifdef KEEP_STD_CURSORS
	    if (cId == IDC_ARROW)
		H_C_ARROW = newCursor;
	    else if (cId == IDC_CROSS)
		H_C_CROSS = newCursor;
	    else if (cId == IDC_IBEAM)
		H_C_IBEAM = newCursor;
	    else if (cId == IDC_ICON)
		H_C_ICON = newCursor;
	    else if (cId == IDC_NO)
		H_C_NO = newCursor;
	    else if (cId == IDC_SIZE)
		H_C_SIZE = newCursor;
	    else if (cId == IDC_SIZEALL)
		H_C_SIZEALL = newCursor;
	    else if (cId == IDC_SIZENESW)
		H_C_SIZENESW = newCursor;
	    else if (cId == IDC_SIZENS)
		H_C_SIZENS = newCursor;
	    else if (cId == IDC_SIZENWSE)
		H_C_SIZENWSE = newCursor;
	    else if (cId == IDC_UPARROW)
		H_C_UPARROW = newCursor;
	    else if (cId == IDC_WAIT)
		H_C_WAIT = newCursor;
#endif /* KEEP_STD_CURSORS */        
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

createCursorSourceForm:sourceBytes maskForm:maskBytes hotX:hx hotY:hy width:w height:h
    "create a cursor given 2 bitmaps (source, mask) and a hotspot"

    |id|

%{
    HCURSOR newCursor;

    if (__isByteArray(sourceBytes)
     && __isByteArray(maskBytes)
     && __bothSmallInteger(hx, hy)
     && __bothSmallInteger(w, h)) {

	newCursor = CreateCursor(hInstance,
				 __intVal(hx), __intVal(hy),
				 __intVal(w), __intVal(h),
				 __ByteArrayInstPtr(maskBytes)->ba_element,
				 __ByteArrayInstPtr(sourceBytes)->ba_element);
	if (newCursor) {
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

destroyCursor:aCursorId

%{  /* NOCONTEXT */

    if (ISCONNECTED) {
	if (__isExternalAddress(aCursorId)) {
	    HCURSOR curs = _HCURSORVal(aCursorId);

	    if (curs) {
#ifdef KEEP_STD_CURSORS
		if ((curs != H_C_ARROW)
		 && (curs != H_C_CROSS)
		 && (curs != H_C_IBEAM)
		 && (curs != H_C_ICON)
		 && (curs != H_C_NO)
		 && (curs != H_C_SIZE)
		 && (curs != H_C_SIZEALL)
		 && (curs != H_C_SIZENESW)
		 && (curs != H_C_SIZENS)
		 && (curs != H_C_SIZENWSE)
		 && (curs != H_C_UPARROW)
		 && (curs != H_C_WAIT)) 
#endif /* KEEP_STD_CURSORS */
		{
		    DestroyCursor(curs);
		}
	    }
	    RETURN ( self );
	}
    }
%}.
    self primitiveFailed
!

needDeviceFormsForCursor
    ^ false
!

shapeNumberFromSymbol:shape
    "given a shape-symbol, return the corresponding cursor-number,
     or nil if no such standard cursor exists."

    "this is pure Win-knowlegde - but you may easily add more"

%{  /* NOCONTEXT */
    if (shape == @symbol(upLeftArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_ARROW));
    }
    if (shape == @symbol(upDownArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZENS));
    }
    if (shape == @symbol(leftRightArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZEWE));
    }
    if (shape == @symbol(text)) {
	RETURN ( __MKSMALLINT( (INT)IDC_IBEAM));
    }
    if (shape == @symbol(wait)) {
	RETURN ( __MKSMALLINT( (INT)IDC_WAIT));
    }
    if (shape == @symbol(crossHair)) {
	RETURN ( __MKSMALLINT( (INT)IDC_CROSS));
    }
    if (shape == @symbol(fourWay)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZE));
    }
%}.
"/    ('WINWORKSTATION: invalid cursorShape:' , shape printString) infoPrintNL.
    ^  nil
! !

!WinWorkstation methodsFor:'drawing'!

copyFromId:sourceId x:srcX y:srcY gc:srcGCId to:destId x:dstX y:dstY gc:dstGCId
		width:w height:h 
    "do a bit-blt; copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

%{  /* NOCONTEXT */

    HDC srcDC = (HDC)0, dstDC = (HDC)0;
    HDC rootDC;
    int deleteSrcDC =0,
	deleteDstDC = 0;

    if (__isExternalAddress(srcGCId)) {
	srcDC = _HDCVal(srcGCId);
	DDPRINTF(("srcDC = %x\n", srcDC));
    } else {
	if (__isExternalAddress(sourceId)) {
	    rootDC = __rootDC;
	    srcDC = CreateCompatibleDC(rootDC);
	    if (srcDC) {
		SelectObject(srcDC, _HWNDVal(sourceId));
		deleteSrcDC = 1;
		DDPRINTF(("created srcDC = %x\n", srcDC));
	    }
	}
    }
    if (! srcDC) {
	goto fail;
    }

    if (__isExternalAddress(dstGCId)) {
	dstDC = _HDCVal(dstGCId);
	DDPRINTF(("dstDC = %x\n", dstDC));
    } else {
	if (__isExternalAddress(destId)) {
	    rootDC = __rootDC;
	    dstDC = CreateCompatibleDC(rootDC);
	    if (dstDC) {
		SelectObject(dstDC, _HWNDVal(destId));
		deleteDstDC = 1;
		DDPRINTF(("created dstDC = %x\n", dstDC));
	    }
	}
    }
    if (! dstDC) {
	goto fail;
    }

    if (__bothSmallInteger(w, h)
     && __bothSmallInteger(srcX, srcY)
     && __bothSmallInteger(dstX, dstY)) {
        
	BitBlt(dstDC, 
	       __intVal(dstX), __intVal(dstY),
	       __intVal(w), __intVal(h),
	       srcDC,
	       __intVal(srcX), __intVal(srcY),
	       SRCCOPY);

	if (deleteDstDC) {
	    DeleteObject(dstDC);
	}
	if (deleteSrcDC) {
	    DeleteObject(srcDC);
	}
	RETURN ( self );
    }

 fail: ;
    if (deleteDstDC) {
	DeleteObject(dstDC);
    }
    if (deleteSrcDC) {
	DeleteObject(srcDC);
    }
%}.
    "badGC, bad sourceDrawableId or destDrawableID
     or any non integer coordinate"

    self primitiveFailed
!

copyPlaneFromId:sourceId x:srcX y:srcY gc:srcDCId to:destId x:dstX y:dstY gc:dstDCId
		width:w height:h 
    "do a bit-blt, but only copy the low-bit plane; 
     copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

    ^ self
	copyFromId:sourceId 
		 x:srcX y:srcY gc:srcDCId 
		to:destId x:dstX y:dstY gc:dstDCId
	     width:w height:h 
!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:aDrawableId with:aGCId
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	DPRINTF(("displayArc not yet implemented\n"));
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:aDrawableId with:aGCId
    "draw a line. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HBRUSH hBrush;
	HPEN hPen;
	POINT p;

	/* DPRINTF(("displayLine: %d/%d -> %d/%d\n", __intVal(x0), __intVal(y0), __intVal(x1), __intVal(y1))); */

	hDC = _HDCVal(aGCId);

	hPen = gcData->hPen;
	if (! hPen) {
	    hPen = gcData->hPen = CreatePen(gcData->lineStyle,
					    gcData->lineWidth,
					    gcData->fgColor);
	    SelectObject(hDC, hPen);
	}

	if (! hPen) {
	    DPRINTF(("displayLine: no pen\n"));
	} else {
	    MoveToEx(hDC, __intVal(x0), __intVal(y0), NULL);
#ifdef BAD_SINCE_LAST_POINT_IS_NOT_DRAWN
	    LineTo(hDC, __intVal(x1), __intVal(y1));
#else
	    p.x = __intVal(x1);
	    p.y = __intVal(y1);
	    PolylineTo(hDC, &p, 1);
#endif
	}

	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayPointX:px y:py in:aDrawableId with:aGCId
    "draw a point. If x/y are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(px, py)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;
	HPEN hPen;
	POINT p;

	hPen = gcData->hPen;
	if (! hPen) {
	    hPen = gcData->hPen = CreatePen(gcData->lineStyle,
					    gcData->lineWidth,
					    gcData->fgColor);
	    SelectObject(hDC, hPen);
	}

	if (! hPen) {
	    DPRINTF(("displayRect: no pen\n"));
	} else {
	    MoveToEx(hDC, __intVal(px), __intVal(py), NULL);
#ifdef BAD_SINCE_LAST_POINT_IS_NOT_DRAWN
	    LineTo(hDC, __intVal(px), __intVal(py));
#else
	    p.x = __intVal(px);
	    p.y = __intVal(py);
	    PolylineTo(hDC, &p, 1);
#endif
	}

	RETURN ( self );
    }
%}.
    "badGC, badDrawable or x/y not integer"
    self primitiveFailed
!

displayPolygon:aPolygon in:aDrawableId with:aGCId
    "draw a polygon, the argument aPolygon is a Collection of individual points, which
     define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints newPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;
	HPEN hPen;
	POINT p;

	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py))
		goto fail;
	}

	hPen = gcData->hPen;
	if (! hPen) {
	    hPen = gcData->hPen = CreatePen(gcData->lineStyle,
					    gcData->lineWidth,
					    gcData->fgColor);
	    SelectObject(hDC, hPen);
	}

	if (! hPen) {
	    DPRINTF(("displayRect: no pen\n"));
	} else {
	    for (i=0; i<num; i++) {
		point = __AT_(aPolygon, __MKSMALLINT(i+1));
		px = _point_X(point);
		py = _point_Y(point);
		if (i == 0) {
		    MoveToEx(hDC, __intVal(px), __intVal(py), NULL);
		} else {
		    if (i == (num-1)) {
			p.x = __intVal(px);
			p.y = __intVal(py);
	    		PolylineTo(hDC, &p, 1);
		    } else {
		        LineTo(hDC, __intVal(px), __intVal(py));
		    }
		}
	    }
	}

	RETURN ( self );
    }
fail: ;
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "draw a rectangle. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    int w, h;
    int xL, yT;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;
	HBRUSH hBrush;
	HPEN hPen;

	xL = __intVal(x);
	yT = __intVal(y);
	w = __intVal(width);
	h = __intVal(height);

	DPRINTF(("displayRectangle: %d/%d -> %d/%d\n", 
			xL, yT, w, h));
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	    hPen = gcData->hPen;
	    if (! hPen) {
		hPen = gcData->hPen = CreatePen(gcData->lineStyle,
						gcData->lineWidth,
						gcData->fgColor);
		SelectObject(hDC, hPen);
	    }

	    if (! hPen) {
		DPRINTF(("displayRect: no pen\n"));
	    } else {
		MoveToEx(hDC, xL, yT, NULL);
		LineTo(hDC, xL+w-1, yT);
		LineTo(hDC, xL+w-1, yT+h-1);
		LineTo(hDC, xL, yT+h-1);
		LineTo(hDC, xL, yT);
	    }
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayString:aString from:index1 to:index2 x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
#   define NLOCALBUFFER 200
    short xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y)) {
	struct gcData *gcData = _GCDATA(aGCId);
	int pX, pY;
	HDC hDC;

	hDC = gcData->hDC;

	pX = __intVal(x);
	pY = __intVal(y);
	pY -= gcData->fontAscent;

	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		RETURN (self);
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;

	    if (__isBytes(aString)) {
		n = __byteArraySize(aString) - nInstBytes - 1;

		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

#ifdef NOTDEF 
	    /* TWOBYTESTRINGS */
	    if (__isWords(aString)) {
		n = (__byteArraySize(aString) - nInstBytes) / 2;

		if (i2 < n) {
		    union {
			char b[2];
			unsigned short s;
		    } u;
		    int i;
		    XChar2b *cp2 = (XChar2b *)0;
		    int mustFree = 0;

		    cp += (i1 * 2);
		    if (l > 1000) l = 1000;

		    /*
		     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
		     * X expects them MSB first
		     * convert as required
		     */

		    u.s = 0x1234;
		    if (u.b[0] != 0x12) {
			if (l <= NLOCALBUFFER) {
			    cp2 = xlatebuffer;
			} else {
			    cp2 = (XChar2b *)(malloc(l * 2));
			    mustFree = 1;
			}
			for (i=0; i<l; i++) {
			    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
			    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			}
			cp = (char *) cp2;
		    }

		    if (opaque == true)
			XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);
		    else
			XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);

		    if (mustFree) {
			free(cp2);
		    }

		    RETURN ( self );
		}
	    }
#endif
	}
    }
#undef NLOCALBUFFER
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

xxxdisplayString:aString x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */

#ifdef NOTDEF
    GC gc;
    Window win;
    unsigned char *cp;
    int n;
    OBJ cls;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(x, y)) {
	gc = _GCVal(aGCId);
	win = _WindowVal(aDrawableId);
	cls = __qClass(aString);

	cp = _stringVal(aString);

	if ((cls == @global(String)) || (cls == @global(Symbol))) {
	    n = _stringSize(aString);
	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	cp += nInstBytes;

	if (__isBytes(aString)) {
	    n = __byteArraySize(aString) - nInstBytes - 1;

	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	/* TWOBYTESTRINGS */
	if (__isWords(aString)) {
	    union {
		char b[2];
		unsigned short s;
	    } u;
	    int i;
	    XChar2b *cp2;
	    int mustFree = 0;

	    n = (__byteArraySize(aString) - nInstBytes) / 2;
	    if (n > 1000) n = 1000;

	    /*
	     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
	     * X expects them MSB first
	     * convert as required
	     */

	    u.s = 0x1234;
	    if (u.b[0] != 0x12) {
		if (n <= NLOCALBUFFER) {
		    cp2 = xlatebuffer;
		} else {
		    cp2 = (XChar2b *)(malloc(n * 2));
		    mustFree = 1;
		}

		for (i=0; i<n; i++) {
		    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
		    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
		}
		cp = (char *) cp2;
	    }

	    if (opaque == true)
		XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);
	    else
		XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);


	    if (mustFree) {
		free(cp2);
	    }

	    RETURN ( self );
	}
    }
#undef NLOCALBUFFER
#endif
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

drawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			  width:imageWidth height:imageHeight 
			      x:srcx y:srcy
			   into:aDrawableId 
			      x:dstx y:dsty 
			  width:w height:h 
			   with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels have bitsPerPixel bits, allowing to draw
     depth and pixel-units to be different.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    "
     sorry; I had to separate it into 2 methods, since XPutImage needs
     an unlimited stack, and thus cannot send primitiveFailed
    "
    (self primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
					width:imageWidth height:imageHeight 
					     x:srcx y:srcy
					  into:aDrawableId 
					     x:dstx y:dsty 
					 width:w height:h 
					  with:aGCId)
    ifFalse:[
	"
	 also happens, if a segmentation violation occurs in the 
	 XPutImage ...
	"
	self primitiveFailed
    ].
!

drawBits:imageBits depth:imageDepth 
		   width:imageWidth height:imageHeight 
		       x:srcx y:srcy
		    into:aDrawableId 
		       x:dstx y:dsty 
		   width:w height:h 
		    with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels must have imageDepth bits.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    ^ self drawBits:imageBits bitsPerPixel:imageDepth depth:imageDepth 
				     width:imageWidth height:imageHeight 
					 x:srcx y:srcy
				      into:aDrawableId 
					 x:dstx y:dsty 
				     width:w height:h 
				      with:aGCId

!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
	       in:aDrawableId with:aGCId
    "fill an arc. If any coordinate is not integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0) && (angle1 >= 0) && (angle2 >= 0)) {
	    DPRINTF(("fillArc not yet implemented\n"));
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillPolygon:aPolygon in:aDrawableId with:aGCId
    "fill a polygon given by its points. 
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	struct gcData *gcData = _GCDATA(aGCId);
        HDC hDC;
        HBRUSH hBrush;
        RECT rct;
	POINT p;

	num = __intVal(numberOfPoints);
	if (num < 3) {
	    RETURN ( self );
	}
	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py))
		goto fail;
	}

        hDC = _HDCVal(aGCId);

/*
        hPen = gcData->hPen;
        if (! hPen) {
            hPen = gcData->hPen = CreatePen(gcData->lineStyle,
                                            gcData->lineWidth,
                                            gcData->fgColor);
            SelectObject(hDC, hPen);
        }
*/

        hBrush = gcData->hBrush;

        if (! hBrush) {
            hBrush = gcData->hBrush = CreateSolidBrush(gcData->fgColor);
	    SelectObject(hDC, hBrush);
        }
        if (! hBrush) {
            DPRINTF(("fillPolygon: no brush\n"));
        } else {
	    BeginPath(hDC);

            for (i=0; i<num; i++) {
                point = __AT_(aPolygon, __MKSMALLINT(i+1));
                px = _point_X(point);
                py = _point_Y(point);
                if (i == 0) {
                    MoveToEx(hDC, __intVal(px), __intVal(py), NULL);
                } else {
                    if (i == (num-1)) {
                        p.x = __intVal(px);
                        p.y = __intVal(py);
                        PolylineTo(hDC, &p, 1);
                    } else {
                        LineTo(hDC, __intVal(px), __intVal(py));
                    }
                }
            }

	    EndPath(hDC);
	    FillPath(hDC);
        }
	RETURN ( self );

fail: ;
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "fill a rectangle. If any coordinate is not integer, an error is triggered."

%{  /* NOCONTEXT */

    int w, h;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);

	DDPRINTF(("fillRect %d/%d -> %d/%d\n", __intVal(x), __intVal(y), w, h));

	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	    struct gcData *gcData = _GCDATA(aGCId);
	    HDC hDC;
	    HBRUSH hBrush;
	    RECT rct;

	    hDC = _HDCVal(aGCId);
	    hBrush = gcData->hBrush;

	    if (! hBrush) {
		hBrush = gcData->hBrush = CreateSolidBrush(gcData->fgColor);
	    }

	    if (! hBrush) {
		DPRINTF(("fillRectangle: no brush\n"));
	    } else {
		rct.left = __intVal(x);
		rct.top = __intVal(y);
		rct.right = rct.left + w; /* FillRect excludes right/bottom */
		rct.bottom = rct.top + h;

		FillRect(hDC, &rct, hBrush);
	    }
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			      width:imageWidth height:imageHeight 
				  x:srcx y:srcy
			       into:aDrawableId 
				  x:dstx y:dsty 
			      width:w height:h 
			       with:aGCId

    "since XPutImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */


fail: ;
%}.
    ^ false
! !

!WinWorkstation methodsFor:'style defaults'!

defaultStyleValueFor:aKey
    "return a default style value, given a key.
     These defaults are used if nothing is specified
     in the style sheet 
     This allows for empty values in style sheets, and defaults
     being provided by the display (which makes sense with Windows,
     where the systemDefaults are used ..."

    <resource: #style (#viewSpacing 
                       #borderColor #borderWidth
                       #viewBackground #shadowColor #lightColor
                      )>

    |clr|

"/    aKey == #shadowColor ifTrue:[
"/        ^ Color black
"/    ].
"/    aKey == #lightColor ifTrue:[
"/        ^ Color white
"/    ].

    aKey == #viewBackgroundColor ifTrue:[
        clr := self getSystemColor:#COLOR_WINDOW.
    ].
    aKey == #textForegroundColor ifTrue:[
        clr := self getSystemColor:#COLOR_WINDOWTEXT
    ].


"/    aKey == #scrollerViewBackgroundColor ifTrue:[
"/        ^ Color white
"/    ].

"/    aKey == #textForegroundColor ifTrue:[
"/        ^ Color black.
"/    ].
"/    aKey == #textBackgroundColor ifTrue:[
"/        ^ Color white.
"/    ].

    clr notNil ifTrue:[^ clr].
    ^ super defaultStyleValueFor:aKey
! !

!WinWorkstation methodsFor:'win32 event handling'!

clearX:x y:y width:w height:h view:aView
    "erase part of a view to its background color.
     WIN speciality, resultimg from WM_PAINT event."

    |oldPaint|

    oldPaint := aView paint.
    aView paint:(aView viewBackground).
    aView fillRectangleX:x y:y width:w height:h.
    aView paint:oldPaint
! !

!WinWorkstation methodsFor:'event handling'!

dispatchEventFor:aViewIdOrNil withMask:eventMask
    "central event handling method:
     get next event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed.
     If the argument aMask is nonNil, only events for this eventMask are
     handled."

    self eventQueuedAlready ifFalse:[
	self getEventFor:aViewIdOrNil withMask:eventMask
    ].

    AbortSignal catch:[
	self dispatchLastEvent
    ].
!

dispatchExposeEventFor:aViewIdOrNil
    "get next expose event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed."

    self dispatchEventFor:aViewIdOrNil withMask:(self eventMaskFor:#expose)
!

dispatchLastEvent
    |theView symS arg butt sibling windowID siblingID propertyID selectionID targetID requestorID
     eventType|

%{  /* STACK: 8000 */
    struct queuedEvent *ev;
    struct inlineCache *ipS;

    static struct inlineCache vid = _ILC1;
    static struct inlineCache conf = _ILC5;
    static struct inlineCache skp = _ILC4;
    static struct inlineCache skr = _ILC4;
    static struct inlineCache exp = _ILC5;
    static struct inlineCache clr = _ILC5;
    static struct inlineCache bp = _ILC4;
    static struct inlineCache br = _ILC4;
    static struct inlineCache bmp = _ILC4;
    static struct inlineCache bsp = _ILC4;
    static struct inlineCache mot = _ILC4;
    static struct inlineCache unmap = _ILC1;
    static struct inlineCache map = _ILC1;
    static struct inlineCache destr = _ILC1;
    static struct inlineCache focOut = _ILC1;
    static struct inlineCache focIn = _ILC1;
    static struct inlineCache act = _ILC2;
    static struct inlineCache pe = _ILC4;
    static struct inlineCache pl = _ILC2;

    int x, y, w, h;
    int keyCode, modifiers, isDoubleClick = 0;
    int isDown = 1;
    int state;
    OBJ upDown;
    char nameBuffer[100];

    DDPRINTF(("dispatchLast\n"));

    ev = deqEvent();
    if (! ev) {
	DPRINTF(("no event in dispatchLastEvent\n"));
	RETURN (false);
    }

    if (ev->ev_hWnd) {
	OBJ t;

        /*
         * very often, its another event for the same view ...
         * avoid creation & lookup then.
         */
        if ((t = __INST(lastId)) != nil) {
            if (__isExternalAddress(t)) {
                if (_HWNDVal(t) == ev->ev_hWnd) {
                    theView = __INST(lastView);
                    if (__isNonNilObject(theView)) {
                        if (__qClass(theView) == nil) {
                            theView = nil;
                        }
                    }
                }
            }
        }

        if (theView == nil) {
	    windowID = __MKOBJ(ev->ev_hWnd);
	    theView = (*vid.ilc_func)(self, @symbol(viewFromId:), nil, &vid, windowID);
        }
    }

    if (theView == nil) {
	DPRINTF(("nil view [hWnd=%x] in dispatchEvent\n", ev->ev_hWnd));

	freeEvent(ev);
	RETURN (false);
    }

    switch (ev->ev_message) {
	    case __WM_SIZEMOVE:
		DPRINTF((">>> WM_SIZEMOVE -> configureX:y:width:height:view:\n"));

		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;
		freeEvent(ev); ev = NULL;
		(*conf.ilc_func)(self,
			     @symbol(configureX:y:width:height:view:),
			     nil, &conf,
			     __MKSMALLINT(x),
			     __MKSMALLINT(y),
			     __MKSMALLINT(w),
			     __MKSMALLINT(h),
			     theView);
		break;

	    case WM_WINDOWPOSCHANGED:
		DPRINTF((">>> WM_WINDOWPOSCHANGED -> configureX:y:width:height:view:\n"));

		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;
		freeEvent(ev); ev = NULL;
		(*conf.ilc_func)(self,
			     @symbol(configureX:y:width:height:view:),
			     nil, &conf,
			     __MKSMALLINT(x),
			     __MKSMALLINT(y),
			     __MKSMALLINT(w),
			     __MKSMALLINT(h),
			     theView);
		break;

	    case WM_SHOWWINDOW:
		if (ev->ev_wParam == TRUE) {
		    DPRINTF((">>> WM_SHOWWINDOW -> mappedView:\n"));
		    (*map.ilc_func)(self,
				     @symbol(mappedView:),
				     nil, &map, theView);
		} else {
		    DPRINTF((">>> WM_SHOWWINDOW -> unMappedView:\n"));
		    (*unmap.ilc_func)(self, 
				       @symbol(unmappedView:),
				       nil, &unmap, theView);
		}
		break;

	    case WM_DESTROY:
		DPRINTF((">>> WM_DESTROY -> destroyedView\n"));
		(*destr.ilc_func)(self,
				   @symbol(destroyedView:),
				   nil, &destr, theView);
		break;

	    case WM_ACTIVATE:
		DPRINTF((">>> WM_ACTIVATE h=%x\n", ev->ev_hWnd));

		switch (LOWORD(ev->ev_wParam)) {
		    case WA_INACTIVE:
			(*act.ilc_func)(self,
				        @symbol(activate:view:),
				        nil,
				        &act,
				        false,
					theView);
/*
			(*focOut.ilc_func)(self,
					    @symbol(focusOutView:),
					    nil,
					    &focOut,
					    theView);
*/
			break;

		    case WA_ACTIVE:
		    case WA_CLICKACTIVE:
			(*act.ilc_func)(self,
				        @symbol(activate:view:),
				        nil,
				        &act,
				        true,
					theView);
/*
			(*focIn.ilc_func)(self,
					   @symbol(focusInView:),
					   nil,
					   &focIn,
					   theView);
*/
			break;
		    default:
			break;
		}
		break;

	    case WM_MOUSEACTIVATE:
		DPRINTF((">>> WM_MOUSEACTIVATE h=%x\n", ev->ev_hWnd));
/*
		(*act.ilc_func)(self,
			        @symbol(activate:view:),
				nil,
				&act,
				true,
				theView);
*/

		(*focIn.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focIn,
				   theView);
		break;

	    case WM_SETFOCUS:
		DPRINTF((">>> WM_SETFOCUS h=%x\n", ev->ev_hWnd));
		(*focIn.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focIn,
				   theView);
		break;

	    case WM_KILLFOCUS:
		DPRINTF((">>> WM_KILLFOCUS h=%x\n", ev->ev_hWnd));
		(*focOut.ilc_func)(self,
				   @symbol(focusOutView:),
				   nil,
				   &focOut,
				   theView);
		break;

	    case WM_ERASEBKGND:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;

		DPRINTF((">>> WM_ERASEBKGND -> clear %d/%d -> %d/%d\n", x, y, w, h));
		(*clr.ilc_func)(self,
			 @symbol(clearX:y:width:height:view:),
			 nil, &clr,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 theView);
		goto expose;
		break;

	    case WM_PAINT:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;

	    expose:
		DPRINTF((">>> WM_PAINT -> expose %d/%d -> %d/%d\n", x, y, w, h));
		(*exp.ilc_func)(self,
			 @symbol(exposeX:y:width:height:view:),
			 nil, &exp,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 theView);
		break;

	    case WM_LBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_LBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;
                
	    case WM_LBUTTONDOWN:
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_MBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_MBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;
                
	    case WM_MBUTTONDOWN:
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_RBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    case WM_RBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;
                
	    case WM_RBUTTONDOWN:
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    commonButtonDown:
		x = ev->ev_x;
		y = ev->ev_y;
		modifiers = ev->ev_modifiers;

		if (isDown) {
		    buttonWindow = ev->ev_hWnd;
		} else {
		    buttonWindow = (HWND)0;
		}

		if (__INST(buttonTranslation) != nil) {
		    butt = __AT_(__INST(buttonTranslation), butt);
		}
		arg = butt;

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		freeEvent(ev); ev = NULL;

		if (isDoubleClick) {
		    ipS = &bmp;
		    symS = @symbol(buttonMultiPress:x:y:view:);
		} else {
		    if (isDown) {
#ifdef NO_LONGERT
			if (modifiers & ShiftMask) {
			    ipS = &bsp;
			    symS = @symbol(buttonShiftPress:x:y:view:);
			} else 
#endif
			{
			    ipS = &bp;
			    symS = @symbol(buttonPress:x:y:view:);
			}
		    } else {
			ipS = &br;
			symS = @symbol(buttonRelease:x:y:view:);
		    }
		}

		if (__isSymbol(arg)) {
		    DPRINTF(("buttonPress/buttonRelease: %s %d/%d\n", 
				__stringVal(arg), x, y));
		} else {
		    DPRINTF(("buttonPress/buttonRelease: %d %d/%d\n", 
				__intVal(arg), x, y));
		}

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);
		break;

	    case __WM_MOUSEENTER:
		x = ev->ev_x;
		y = ev->ev_y;
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSEENTER: %d/%d %x\n", x, y, state));
		(*pe.ilc_func)(self, @symbol(pointerEnter:x:y:view:),
				    nil, &pe,
				    __MKSMALLINT(state),
				    __MKSMALLINT(x),
				    __MKSMALLINT(y),
				    theView);
		break;

	    case __WM_MOUSELEAVE:
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSELEAVE: %d/%d %x\n", x, y, state));
		(*pl.ilc_func)(self, @symbol(pointerLeave:view:),
				    nil, &pl,
				    __MKSMALLINT(state),
				    theView);
		break;
        
	    case WM_MOUSEMOVE:

		x = ev->ev_x;
		y = ev->ev_y;
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSEMOVE: %d/%d %x\n", x, y, state));

#ifdef NOTDEF
		if (buttonWindow) {
		    if (buttonWindow != ev->ev_hWnd) {
			/*
			 * translate for window, where button was pressed
			 * originally (X motion semantics)
			 */
			{
			    POINT p;

			    p.x = x;
			    p.y = y;
			    MapWindowPoints(ev->ev_hWnd, buttonWindow, &p, 1);
			    x = p.x;
			    y = p.y;
			    DPRINTF(("xlated to %d/%d for %x\n",
					x, y, buttonWindow));
			}
			windowID = __MKOBJ(buttonWindow);
			theView = (*vid.ilc_func)(self, @symbol(viewFromId:), 
						  nil, &vid, windowID);
		    }
		}
#endif

		(*mot.ilc_func)(self, @symbol(buttonMotion:x:y:view:),
				    nil, &mot,
				    __MKSMALLINT(state),
				    __MKSMALLINT(x),
				    __MKSMALLINT(y),
				    theView);
		break;
                
	    case WM_CHAR:
		DPRINTF((">>> WM_CHAR: %d/%d\n", x, y));
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skp;
		upDown = true;
		goto keyPressAndRelease;

	    case WM_SYSKEYUP:
	    case WM_KEYUP:
		DPRINTF((">>> WM_KEYUP / SYSKEYUP: %d/%d\n", x, y));
		symS = @symbol(keyRelease:x:y:view:);
		ipS = &skr;
		upDown = false;
		goto keyPressAndRelease;

	    case WM_SYSKEYDOWN:
	    case WM_KEYDOWN:
		DPRINTF((">>> WM_KEYDOWN / SYSKEYDOWN: %d/%d\n", x, y));
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skp;
		upDown = true;
		/* FALL INTO */

	    keyPressAndRelease: ;

		x = ev->ev_x;
		y = ev->ev_y;

#ifdef NOTDEF
		{
		    BYTE vKeyState[256];
		    char buff[5];

		    GetKeyboardState(vKeyState);
		    ToAscii(ev->ev_keyCode, ev->ev_scanCode, vKeyState, &buff; 0);
		}
#endif

		keyCode = ev->ev_keyCode;
		modifiers = ev->ev_modifiers;

		if (modifiers & TRANSLATED_KEY) {
		    if (modifiers & ControlMask) {
			if (keyCode < 0x20) {
			    keyCode = keyCode + 'a' - 1;
			    if (modifiers & ShiftMask) {
				keyCode = keyCode - 'a' + 'A';
			    }
			}
		    } else if (modifiers & (MetaMask | AltMask)) {
			if (! (modifiers & ShiftMask)) {
			    if ((keyCode >= 'A') && (keyCode <= 'Z')) {
				keyCode = keyCode - 'A' + 'a';
			    }
			}
		    }
		    arg = __MKCHARACTER(keyCode & 0xFF);
		} else {
		    switch (keyCode) {
			case '\t':
			    arg = @symbol(Tab);
			    break;

			case '\b':
			    arg = @symbol(BackSpace);
			    break;

			case '\r':
			    arg = @symbol(Return);
			    break;

			case 0x1b:
			    arg = @symbol(Escape);
			    break;

			default:
			    nameBuffer[0] = 0;
			    GetKeyNameText(ev->ev_scanCode, nameBuffer, sizeof(nameBuffer));
			    DPRINTF(("char is <%s>\n", nameBuffer));
			    if (strlen(nameBuffer) == 1) {
				arg = __MKCHARACTER(keyCode & 0xFF);
			    } else {
				arg = __MKSYMBOL(nameBuffer, (OBJ *)0);
			    }
			    break;
		    }
		}

		DPRINTF(("%s: code=%x mod=%x\n", __stringVal(symS),
				keyCode, modifiers));

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		freeEvent(ev); ev = NULL;

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);

		break;

	    default:
		DPRINTF((">>> unhandled event: %x\n", ev->ev_message));
		break;
    }

    if (ev) {
	freeEvent(ev);
    }
%}.
    ^ true
!

disposeEventsWithMask:aMask for:aWindowIdOrNil
    "dispose (throw away) specific events. If aWindowId is nil,
     events matching the mask are thrown away regardless of which
     view they are for. Otherwise, only matching events for that 
     view are flushed."

%{  /* NOCONTEXT */

%}.
    self primitiveFailed
!

eventMaskFor:anEventSymbol
    "return the eventMask bit-constant corresponding to an event symbol"

%{  /* NOCONTEXT */

    int m = 0;

#ifdef NOTDEF
    if (anEventSymbol == @symbol(keyPress)) m = KeyPressMask;
    else if (anEventSymbol == @symbol(keyRelease)) m = KeyReleaseMask;
    else if (anEventSymbol == @symbol(buttonPress)) m = ButtonPressMask;
    else if (anEventSymbol == @symbol(buttonRelease)) m = ButtonReleaseMask;
    else if (anEventSymbol == @symbol(buttonMotion)) m = ButtonMotionMask;
    else if (anEventSymbol == @symbol(pointerMotion)) m = PointerMotionMask;
    else if (anEventSymbol == @symbol(expose)) m = ExposureMask;
    else if (anEventSymbol == @symbol(focusChange)) m = FocusChangeMask;
    else if (anEventSymbol == @symbol(enter)) m = EnterWindowMask;
    else if (anEventSymbol == @symbol(leave)) m = LeaveWindowMask;
    else if (anEventSymbol == @symbol(keymapState)) m = KeymapStateMask;
    else if (anEventSymbol == @symbol(visibilityChange)) m = VisibilityChangeMask;
    else if (anEventSymbol == @symbol(structureNotify)) m = StructureNotifyMask;
    else if (anEventSymbol == @symbol(resizeRedirect)) m = ResizeRedirectMask;
    else if (anEventSymbol == @symbol(propertyChange)) m = PropertyChangeMask;
    else if (anEventSymbol == @symbol(colormapChange)) m = ColormapChangeMask;
#endif
    RETURN (__MKSMALLINT(m));
%}
!

eventPending
    "return true, if any event is pending. 
     This looks for both the internal queue and the display connection."

%{  /* NOCONTEXT */
    MSG msg;

    if (__INST(inRecursiveDispatch) == true) {
	RETURN (false);
    }

    if (eventQueueHead) {
	RETURN (true);
    }
    if (GetQueueStatus(QS_ALLINPUT)
     && PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE)) {
	RETURN (true);
    }
%}.
    ^ false
!

eventPending:anEventSymbol for:aWindowIdOrNil
    "return true, if a specific event is pending"

    ^ self eventsPending:(self eventMaskFor:anEventSymbol) for:aWindowIdOrNil withSync:false
!

eventPendingWithSync:doSync
    "return true, if any event is pending. 
     The doSync argument is ignored here - in windows, all drawing is synchronous."

    ^ self eventPending
!

eventQueued
    "return true, if any event is queued"

    ^ self eventQueuedAlready

    "Created: 12.12.1995 / 21:43:00 / stefan"
!

eventQueuedAlready
    "return true, if any event is queued internally.
     (i.e. in X's internal event queue, which is both filled by explicit
      nextEvent calls AND whenever drawing is done and events are pending on
      the display connection)."

%{  /* NOCONTEXT */

    DDPRINTF(("peek q - "));
    if (eventQueueHead) {
	DDPRINTF(("true\n"));
	RETURN (true);
    }
    DDPRINTF(("false\n"));
    RETURN ( false );
%}
!

eventsPending:anEventMask for:aWindowIdOrNil withSync:doSync
    "return true, if any of the masked events is pending.
     The doSync argument is ignored here - in windows, all drawing is synchronous."

%{  /* NOCONTEXT */

#ifdef DOES_NOT_WORK
    getWinEvents(1);
    DPRINTF(("************* peek mask %x - not implemented\n", __intVal(anEventMask)));
#endif    
%}.
    ^ false
!

exposeEventPendingFor:aWindowIdOrNil withSync:doSync
    "return true, if any expose event is pending for a specific view,
     or any view (if the arg is nil).
     This is an X specific interface - not used on windows (scrolling is synchronous)"

    ^ false
!

getEventFor:aViewIdOrNil withMask:eventMask
    "read next event - put into local eventBuffer. 
     If aViewIdOrNil is nil, events for any view are fetched; 
     otherwise only events for that specific view will be fetched.
     Returns true, if there was an event, false otherwise."

%{  /* STACK:16000 */
    int hasEventQueued;

    DPRINTF(("... > getEvent\n"));
    hasEventQueued = eventQueueHead ? 1 : 0;
    if (!hasEventQueued) {
        if (GetQueueStatus(QS_ALLINPUT)) {
            getWinEvents(0);
	    hasEventQueued = eventQueueHead ? 1 : 0;
	}
    }
    if (hasEventQueued) {
	/* no need to copy into buffer (will be dequeued) */
	DPRINTF(("... < getEvent true\n"));
	RETURN (true);
    }
    DPRINTF(("... < getEvent false\n"));
%}.
    ^ false
!

handleAllEvents
    "from now on, handle any kind of event.
     Ignored on windows systems."

!

handleExposeOnlyFor:aView
    "from now on, handle expose events only.
     Ignored on windows systems."

!

mappingChanged:what event:eB
    "One of Keyboard-, Modifier- or PointerMap has change, probably by xmodmap.
     Tell xlib about the fact."

    (what == #mappingKeyboard or:[what == #mappingModifier]) ifTrue:[
	self refreshKeyboardMapping:eB.
	"Maybe some of our modifiers have been changed"
	self initializeModifierMappings.
    ].

    "Created: 1.12.1995 / 16:28:23 / stefan"
!

setEventMask:aMask in:aWindowId
    "tell X that we are only interested in events from aMask, which
     is the bitwise or of the eventMask bits (see 'eventMaskFor:')"

    ^ self
! !

!WinWorkstation methodsFor:'event sending'!

sendKeyOrButtonEvent:typeSymbol x:xPos y:yPos keyOrButton:keySymCodeOrButtonNr state:stateMask toViewId:targetId
    "send a keyPress/Release or buttonPress/Release event to some (possibly alien) view.
     TypeSymbol must be one of: #keyPress, #keyRelease, #buttonPress , #buttonRelease.
     For buttonEvents, the keySymCodeOrButtonNr must be the buttons number (1, 2 ...);
     for key events, it can be either a symbol (as listen in X's keySyms)
     or a numeric keysym code. If state is nil, the modifier bits (shift & control)
     are computed from the keyboardMap - if non-nil, these are passed as modifierbits.
     The non-nil case is the lowlevel entry, where state must include any shift/ctrl information
     (not very user friendly)"

    ^ false
!

simulateKeyboardInput:aCharacterOrString inViewId:viewId
    "send input to some other view, by simulating keyPress/keyRelease
     events. 
     Only a few control characters are supported.
     Notice: not all alien views allow this kind of synthetic input;
	     some simply ignore it."

    |control code state|

    aCharacterOrString isString ifTrue:[
	aCharacterOrString do:[:char |
	    self simulateKeyboardInput:char inViewId:viewId
	].
	^ self
    ].

    control := false.
    code := aCharacterOrString asciiValue.

    (aCharacterOrString == Character cr) ifTrue:[
	code := #Return
    ] ifFalse:[
	(aCharacterOrString == Character tab) ifTrue:[
	    code := #Tab 
	] ifFalse:[
	    (aCharacterOrString == Character esc) ifTrue:[
		code := #Escape 
	    ]
	]
    ].

    control ifTrue:[
	state := self controlMask
    ].


    "/ the stuff below should not be needed 
    "/ (sendKeyOrButtonevent should be able to figure out things itself)
    "/ however, on some linux systems it seems to not work correctly.
    "/ Hopefully, this is correct ...

    code isNumber ifTrue:[
	code >= $A asciiValue ifTrue:[
	    code <= $Z asciiValue ifTrue:[
		state := self shiftMask
	    ]
	]
    ].

    self sendKeyOrButtonEvent:#keyPress x:0 y:0 keyOrButton:code state:state toViewId:viewId.
    self sendKeyOrButtonEvent:#keyRelease x:0 y:0 keyOrButton:code state:state toViewId:viewId

    "
      sending input to some (possibly alien) view:

      |point id|

      point :=  Display pointFromUser.
      id := Display viewIdFromPoint:point.
      Display simulateKeyboardInput:'Hello_world' inViewId:id
    "

    "Modified: 11.6.1996 / 10:59:42 / cg"
! !

!WinWorkstation methodsFor:'font stuff'!

createFontFor:aFontName
    "a basic method for font allocation; this method allows
     any font to be aquired (even those not conforming to
     standard naming conventions, such as cursor, fixed or k14)"

%{
    HGDIOBJ hFont;
    char *fn;

    if (__isString(aFontName)) {
	fn = __stringVal(aFontName);
	if (strcmp(fn, "fixed") == 0) {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	} else if (strcmp(fn, "variable") == 0) {
	    hFont = GetStockObject(ANSI_VAR_FONT);
	} else {
	    hFont = (HGDIOBJ)0;
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	}
	if (hFont) {
	    DPRINTF(("createFontFor:aFontName: %s -> %x\n", fn, hFont));
	    RETURN ( __MKOBJ(hFont) );
	}
    }
%}.
    ^ nil
!

fontsInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font in aFamily/aFace/aStyle
     on this display.
     On WinWorkStations there is curently no style or Face
     But only those matching filter (if nonNIl)."

    |allFonts fonts|

    allFonts := self listOfAvailableFonts.
    allFonts isNil ifTrue:[^ nil].

    fonts := Set new.
    allFonts do:[:fntDescr |
	(aFamilyName sameAs:(fntDescr family)) ifTrue:[
	    (filter isNil or:[filter value:fntDescr]) ifTrue:[
		fonts add:fntDescr
	    ]
	]
    ].
    ^ fonts
!

fontsInFamily:aFamilyName face:aFaceName filtering:filter
    "return a set of all available fonts in aFamily/aFace on this display.
     On WinWorkStations there is curently Face
     But only thise matching filter (if nonNil)."

    |allFonts fonts|

    allFonts := self listOfAvailableFonts.
    allFonts isNil ifTrue:[^ nil].

    fonts := Set new.
    allFonts do:[:fntDescr |
	(aFamilyName sameAs:(fntDescr family)) ifTrue:[
	    (filter isNil or:[filter value:fntDescr]) ifTrue:[
		fonts add:fntDescr
	    ]
	]
    ].
    ^ fonts
!

fontMetricsOf:fontId into:aBlock
    "evaluate aBlock, passing a fonts metrics as arguments"

    |encoding avgAscent avgDescent
     maxAscent maxDescent minWidth maxWidth avgWidth|

%{
    HGDIOBJ hFont;
    HGDIOBJ prevFont;
    HDC rootDC;
    TEXTMETRIC tmet;
    int len;

    if (ISCONNECTED) {
	if (__isExternalAddress(fontId)) {
	    hFont = _HGDIOBJVal(fontId);
	    /*
	     * temporarily set this font in the root context
	     */
	    rootDC = __rootDC;
	    prevFont = SelectObject(rootDC, hFont);
	    GetTextMetrics(rootDC, &tmet);
	    SelectObject(rootDC, prevFont);

	    avgAscent = __MKSMALLINT(tmet.tmAscent);
	    avgDescent = __MKSMALLINT(tmet.tmDescent);
	    maxAscent = __MKSMALLINT(tmet.tmAscent);
	    maxDescent = __MKSMALLINT(tmet.tmDescent);
	    minWidth = __MKSMALLINT(tmet.tmAveCharWidth);
	    maxWidth = __MKSMALLINT(tmet.tmMaxCharWidth);
	    avgWidth = __MKSMALLINT(tmet.tmAveCharWidth);
	    DPRINTF(("textMetrics h=%x  avgAsc=%d avgDesc=%d minW=%d maxW=%d avgW=%d\n",
			hFont, tmet.tmAscent, tmet.tmDescent, tmet.tmAveCharWidth, tmet.tmMaxCharWidth,
			tmet.tmAveCharWidth));
	}
    }
%}.
    encoding := #iso8859.
    aBlock value:encoding
	   value:avgAscent
	   value:avgDescent
	   value:maxAscent
	   value:maxDescent
	   value:minWidth
	   value:maxWidth
	   value:avgWidth
!

fullNameOf:aFontId
    "the fonts fullName - this is very device specific and should only be
     used for user feed-back (for example: in the fontPanel).
     If the display/font do not provide that info, return nil."

    ^ nil
!

getAvailableFontsMatching:pattern
    "return an Array filled with font names matching aPattern"

    ^ nil
!

getDefaultFont
    "return a default font id - used when class Font cannot
     find anything usable"

     ^ self createFontFor:'fixed'
!

getFontWithFamily:familyString face:faceString
	    style:styleArgString size:sizeArg encoding:encodingSym

    "try to get the specified font, if not available, try next smaller
     font. Access to X-fonts by name is possible, by passing the X font name
     as family and the other parameters as nil. For example, the cursor font
     can be aquired that way."

    |styleString theName theId xlatedStyle id spacing|

    styleString := styleArgString.

    "special: if face is nil, allow access to X-fonts"
    faceString isNil ifTrue:[
	sizeArg notNil ifTrue:[
	    theName := familyString , '-' , sizeArg printString
	] ifFalse:[
	    theName := familyString
	].
	theName isNil ifTrue:[
	    "
	     mhmh - fall back to the default font
	    "
	    theName := 'fixed'
	].
	theId := self createFontFor:theName.
	theId isNil ifTrue:[
	    theId := self getDefaultFont
	].
	^ theId
    ].

    "/ spacing other than 'normal' is contained as last component
    "/ in style
    styleString notNil ifTrue:[
	((styleString endsWith:'-narrow') 
	 or:[styleString endsWith:'-semicondensed']) ifTrue:[
	    |i|
	    i := styleString lastIndexOf:$-.
	    spacing := styleString copyFrom:(i+1).
	    styleString := styleString copyTo:(i-1).
	] ifFalse:[
	    spacing := 'normal'.
	].
    ].

    xlatedStyle := styleString.
    xlatedStyle notNil ifTrue:[
	xlatedStyle := xlatedStyle first asString
    ].

    id := self 
	    getFontWithFoundry:'*'
	    family:familyString asLowercase
	    weight:faceString
	    slant:xlatedStyle
	    spacing:spacing
	    pixelSize:nil
	    size:sizeArg 
	    registry:encodingSym
	    encoding:'*'.

    id isNil ifTrue:[
	(encodingSym notNil and:[encodingSym ~= '*']) ifTrue:[
	    "/ too stupid: encodings come in both cases
	    "/ and X does not ignore case
	    "/
	    id := self 
		    getFontWithFoundry:'*'
		    family:familyString asLowercase
		    weight:faceString
		    slant:xlatedStyle
		    spacing:spacing
		    pixelSize:nil
		    size:sizeArg 
		    registry:encodingSym asUppercase
		    encoding:'*'.
	    id isNil ifTrue:[
		id := self 
			getFontWithFoundry:'*'
			family:familyString asLowercase
			weight:faceString
			slant:xlatedStyle
			spacing:spacing
			pixelSize:nil
			size:sizeArg 
			registry:encodingSym asLowercase
			encoding:'*'.
	    ]
	]
    ].
    ^ id

    "Modified: 24.2.1996 / 22:37:24 / cg"
    "Modified: 4.7.1996 / 11:38:47 / stefan"
!

getFontWithFoundry:foundry family:family weight:weight
	      slant:slant spacing:spc pixelSize:pSize size:size 
	      registry:registry encoding:encoding

    "get the specified font, if not available, return nil.
     This is the new font creation method - all others will be changed to
     use this entry.
     Individual attributes can be left empty (i.e. '') or nil to match any.

     foundry: 'adobe', 'misc', 'dec', 'schumacher' ... usually '*'
     family:  'helvetica' 'courier' 'times' ...
     weight:  'bold' 'medium' 'demi' ...
     slant:   'r(oman)' 'i(talic)' 'o(blique)'
     spacing: 'narrow' 'normal' semicondensed' ... usually '*'
     pixelSize: 16,18 ... usually left empty
     size:      size in point (1/72th of an inch)
     registry:  iso8859, sgi ... '*'
     encoding:  vendor specific encoding (usually '*')
    "
    " 
	Windows 95 allows the creation of a font with the following parameters

		nHeight
		nWidth
		nEscapement
		nOrientation
		fnWeight        FW_DONTCARE, FW_NORMAL, FW_MEDIUM, FW_BOLD, ...
		fdwItalic       TRUE or FALSE
		fdwUnderline    TRUE or FALSE
		fdwStrikeOut    TRUE or FALSE
		fdwCharSet      ANSI_CHARSET, UNICODE_, SYMBOL_, SHIFTJIS_,...
		fdwOutputPrecision      DEFAULT, STRING, CHAR, ...
		fdwClipPrecision        DEFAULT, CHAR, STROKE, MASK, ...
		fdwQuality      DEFAULT, DRAFT, or PROOF.
		fdwPitchAndFamily
			DEFAULT, FIXED or VARIABLE pitch
			DECORATIVE, DONTCASE, MODERN, ROMAN, SCRIPT, or SWISS.
		lpszFace
			Typeface Name

	These two above descriptions will be matched as follows:

		foundry - ignored
		family  - mapped to type face name.
		weight  - mapped to fnWeight
		slant   - NOT USED INITIALLY  user for style
		spacing - NOT USED INITIALLY
		pixelSize - NOT USED INITIALLY
		size      - mapped to nHeight
		registry  - NOT USED INITIALLY
		encoding  - NOT USED INITIALLY used for dwType device, raster or truetype
	"
%{
    HGDIOBJ hFont;
    int  nHeight, nWidth, nEscapement, nOrientation;
    char* work;
    char* work2;
    DWORD fnWeight;
    DWORD fdwItalic;
    DWORD fdwUnderline;
    DWORD fdwStrikeOut;
    DWORD fdwCharSet;
    DWORD fdwOutputPrecision;
    DWORD fdwClipPrecision;
    DWORD fdwQuality;
    DWORD fdwPitchAndFamily;
    LPCTSTR lpszFace;
    static char temp[33];

/* INITIALIZE */
    strcpy( temp, "                           " );
    lpszFace = &temp[0];
    strcpy( lpszFace, "NULL" );
    nHeight  = 0;
    nWidth   = 0;
    nEscapement = 0;
    nOrientation = 0;
    fnWeight = FW_NORMAL;
    fdwItalic = FALSE;
    fdwUnderline = FALSE;
    fdwStrikeOut = FALSE;
    fdwCharSet   = ANSI_CHARSET;
    fdwOutputPrecision = OUT_DEFAULT_PRECIS;
    fdwClipPrecision   = CLIP_DEFAULT_PRECIS;
    fdwQuality         = DEFAULT_QUALITY;
    fdwPitchAndFamily  = FF_DONTCARE;
    
/* SET VALUES */
    if ( __isString( family ) ) {
	work = __stringVal( family );
	if ( strcmp( work, "nil" ) != 0 ) {
	    strncpy( lpszFace, work, 32 );
	} 
    }
    if( __isString( weight ) ) {
	work = __stringVal( weight );
	if( strcmp( work, "bold" ) == 0 ) {
	    fnWeight = FW_BOLD;
    } else {
	if( strcmp( work, "medium" ) == 0 ) {
	    fnWeight = FW_MEDIUM;
	    } else { 
		if( strcmp( work, "demi" ) == 0 )
		    fnWeight = FW_LIGHT;
	    }
	}
    }
    if(__isSmallInteger( size ) )
    {
	nHeight = __intVal( size );
    }
    work2 = __stringVal( slant );
    work  = __stringVal( slant );
    if( strncmp( work2, "italic", 6 ) == 0 )
    {
	fdwItalic = TRUE;
	if( work2[6] = '-' )
	   strncpy( work, &work2[7], ( strlen( work2 ) - 7 ) );
    }
    if( strncmp( work, "underline", 9 ) == 0 )
    {
	fdwUnderline = TRUE;
	if( work[10] == '-' )
	   strncpy( work2, &work[11], ( strlen( work ) - 10 ) );
    }
    if( strncmp( work2, "strikeOut", 9 ) == 0 )
	fdwStrikeOut = TRUE;

    hFont = CreateFont( nHeight,
			nWidth,
			nEscapement,
			nOrientation,
			fnWeight,
			fdwItalic,
			fdwUnderline,
			fdwStrikeOut,
			fdwCharSet,
			fdwOutputPrecision,
			fdwClipPrecision,
			fdwQuality,
			fdwPitchAndFamily,
			lpszFace );

    if( hFont != NULL )
    {
	DPRINTF(("createFontWithFoundry: %x\n", hFont));
	RETURN ( __MKOBJ(hFont) );
    }
    DPRINTF(("***** ERROR createFontWithFoundry failed ERROR *****\n" ));
%}.
    ^ nil

    "
     Display getFontWithFoundry:'*'
			 family:'courier'
			 weight:'medium'
			  slant:'r'
			spacing:nil
		      pixelSize:nil
			   size:13
		       registry:'iso8859'
		       encoding:'*'
    "

    "new NT Version: 20.2.1997 / 22:33:29 / dq"
!

listOfAvailableFonts
    "return a list with all available fonts on this display.
     Since this takes a long time, keep the result of the query for the
     next time. The elements of the returned collection are instances of
     FontDescription."

    |list typeFaceList|

    listOfFonts isNil ifTrue:[
	list         := OrderedCollection new.
	typeFaceList := OrderedCollection new.

%{
	HDC dc;
	HDC rootDC;

	rootDC = __rootDC;
	dc = CreateCompatibleDC( rootDC );
	if( EnumFonts( dc, NULL, EnumFPTypeFace, &(typeFaceList) ) )
	    DPRINTF(("EnumFonts successful\n"));
	DeleteDC(dc);
%}.

    Transcript showCR:typeFaceList.

    typeFaceList do:[:typeFace |

%{
	HDC dc;
	HDC rootDC;
	char *cp;

	if (__isString(typeFace)) {
	    rootDC = __rootDC;
	    dc = CreateCompatibleDC( rootDC );
	    if( EnumFonts( dc, __stringVal(typeFace), EnumFontsProc, &(list) ) )
		    DPRINTF(("EnumFonts Successful\n"));
	    if( DeleteDC( dc ) ) 
		    DPRINTF(("Divice Context sucessfully deleted"));
	}
%}.
	0
	].

    Transcript showCR:list.
    listOfFonts := list collect:[ :anArray |
					| fntDescr family face style size encoding |
					family := anArray at:14.
					face   := anArray at:5.
					style  := anArray at:16.
					size   := anArray at:1.
					encoding := anArray at:15.
                                        
					fntDescr := FontDescription 
							family:family
							face:face
							style:style
							size:size
							encoding:encoding.
					fntDescr
				].
    ].

    ^ listOfFonts

    "
     Display listOfAvailableFonts.

     Display getAvailableFontsMatching:'*'.
    "

    "Modified: 27.9.1995 / 10:54:47 / stefan"
    "Modified: 17.4.1996 / 15:27:57 / cg"
!

releaseFont:aFontId

    ^ self
!

sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font sizes in aFamily/aFace/aStyle
     on this display.
     Redefined to handle X's special case of 0-size (which stands for any)"

    |sizes|

    sizes := super sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter.
    (sizes notNil and:[sizes includes:0]) ifTrue:[
	"special: in X11R5 and above, size 0 means:
	 there are scaled versions in all sizes available"

	^ #(4 5 6 7 8 9 10 11 12 14 16 18 20 22 24 28 32 48 64)
    ].
    ^ sizes

    "
     Display sizesInFamily:'courier' face:'bold' style:'roman'
    "

    "Created: 27.2.1996 / 01:38:15 / cg"
!

widthOf:aString from:index1 to:index2 inFont:aFontId

%{  /* NOCONTEXT */
    char *cp;
    int len, n, i1, i2, l;
    OBJ cls;
    int nInstBytes;

    if (ISCONNECTED) {
	if (__bothSmallInteger(index1, index2)
	 && __isExternalAddress(aFontId)
	 && __isNonNilObject(aString)) {
	    HDC rootDC;
	    HGDIOBJ hFont;
	    SIZE tsize;

	    rootDC = __rootDC;
	    hFont = _HGDIOBJVal(aFontId);

	    i1 = __intVal(index1) - 1;
	    cls = __qClass(aString);

	    if (i1 >= 0) {
		i2 = __intVal(index2) - 1;
		if (i2 < i1) {
		    RETURN ( __MKSMALLINT( 0 ) );
		}

		cp = (char *) _stringVal(aString);
		l = i2 - i1 + 1;

		if ((cls == @global(String)) || (cls == @global(Symbol))) {
		    n = _stringSize(aString);
		    if (i2 < n) {
			cp += i1;

			SelectObject(rootDC, hFont);
			GetTextExtentPoint(rootDC, cp, l, &tsize);
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}

		nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
		cp += nInstBytes;

		if (__isBytes(aString)) {
		    n = __byteArraySize(aString) - nInstBytes;
		    if (i2 < n) {
			cp += i1;

			SelectObject(rootDC, hFont);
			GetTextExtentPoint(rootDC, cp, l, &tsize);
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}

#ifdef NOTDEF
		/* TWOBYTESTRINGS */
		if (__isWords(aString)) {
		    n = (__byteArraySize(aString) - nInstBytes) / 2;

		    if (i2 < n) {
			union {
			    char b[2];
			    unsigned short s;
			} u;
			int i;
			XChar2b *cp2 = (XChar2b *)0;
			int mustFree = 0;

			cp += (i1 * 2);
			if (l > 1000) l = 1000;

			/*
			 * ST/X TwoByteStrings store the asciiValue in native byteOrder;
			 * X expects them MSB first
			 * convert as required
			 */

			u.s = 0x1234;
			if (u.b[0] != 0x12) {
			    if (l <= NLOCALBUFFER) {
				cp2 = xlatebuffer;
			    } else {
				cp2 = (XChar2b *)(malloc(l * 2));
				mustFree = 1;
			    }
			    for (i=0; i<l; i++) {
				cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
				cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			    }
			    cp = (char *) cp2;
			}
			BEGIN_INTERRUPTSBLOCKED
			len = XTextWidth16(f, (XChar2b *)cp, l);
			END_INTERRUPTSBLOCKED

			if (mustFree) {
			    free(cp2);
			}

			RETURN ( __MKSMALLINT(len) );
		    }
		}
#endif
	    }
	}
    }
#undef NLOCALBUFFER
%}.
    self primitiveFailed.
    ^ nil
! !

!WinWorkstation methodsFor:'grabbing '!

allowEvents:mode
!

grabKeyboardIn:aWindowId
    "grab the keyboard"

!

grabPointerIn:aWindowId withCursor:aCursorId pointerMode:pMode keyboardMode:kMode confineTo:confineId
    "grap the pointer - return true if ok"
%{
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	SetCapture(hWnd);
    }
%}.
    ^ true
!

ungrabKeyboard
    "release the keyboard"

    activeKeyboardGrab := nil
!

ungrabPointer
    "release the pointer"

%{
    ReleaseCapture();
%}.
    activePointerGrab := nil
! !

!WinWorkstation methodsFor:'graphic context stuff'!

noClipIn:aWindowId gc:aGCId
    "disable clipping rectangle"

%{  /* NOCONTEXT */

 
    if (__isExternalAddress(aWindowId)
     && __isExternalAddress(aGCId)) {
        RECT wRect;
        HRGN region = NULL; 
	HWND hWnd = _HWNDVal(aWindowId);
	HDC hDC = _HDCVal(aGCId);
	struct gcData *gcData = _GCDATA(aGCId);

        if (GetWindowRect(hWnd, &wRect)) {
/*
	    region = CreateRectRgn(wRect.left, wRect.top, wRect.right, wRect.bottom);
*/
	    if (SelectClipRgn(hDC, region) == ERROR ) {
	        DPRINTF((" clipping region release unsuccessful\n" ));
	    } else {
	        if (gcData->clipRgn) {
	            DeleteObject(gcData->clipRgn);
		}
	        gcData->clipRgn = region;
	    }
	    RETURN (self);
	}
    }
%}.
    self primitiveFailed
!

setBackground:bgColorIndex in:aGCId
    "set background color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF bgColor;

	hDC = _HDCVal(aGCId);
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DPRINTF(("setBackground: %x\n", bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setBitmapMask:aBitmapId in:aGCId
    "set or clear the drawing mask - a bitmap mask using current fg/bg"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("masks not yet implemented\n"));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setClipByChildren:aBool in:aWindowId gc:aGCId
    "enable/disable drawing into child views"

%{  /* NOCONTEXT */

    HDC  hDC;
    HWND win;
    LONG style, oldstyle;

#ifdef OLD
    if (ISCONNECTED && __isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	if( win = WindowFromDC( hDC ) ) {
	    if( style = GetWindowLong( win, GWL_STYLE ) ) {
		DPRINTF(("style retrieved %x\n", style ));
		if( aBool == true ) {
		    /* set clip by child */

		    style = style | WS_CLIPCHILDREN;
		    DPRINTF(("style updated to be set %x\n", style ));
		    if( ( oldstyle = SetWindowLong( win, GWL_STYLE, style ) ) == 0 ) {
			DPRINTF(("clipping by child failed - could not set value\n"));
		    } else {
			DPRINTF(("Style set %x OLD STYLE: %x\n", style, oldstyle ));
		    }
		} else {
		    /* unset clip by child */

		    if( style & WS_CLIPCHILDREN ) {
			/* clip by child is set */

			style = style ^ WS_CLIPCHILDREN;
			DPRINTF(("style updated to be reset %x\n", style ));
			if( ( oldstyle = SetWindowLong( win, GWL_STYLE, style ) ) == 0 ) {
			    DPRINTF(("clipping by child failed - could not set value\n"));
			} else {
			    DPRINTF(("Style reset %x OLD STYLE: %x\n", style, oldstyle ));
			}
		    } else {
			DPRINTF((" No need to set style %x : %x\n", style, WS_CLIPCHILDREN ));
		    }
		}
	    } else {
		DPRINTF(("clipping by child failed - could not retrieve value\n"));
	    }
	} else {
	    DPRINTF(("clipping by child failed - could not retrieve window from DC\n" ));
	}
    }
#else
    if (ISCONNECTED && __isExternalAddress(aWindowId)) {
	win = _HWNDVal(aWindowId);
	if (win) {
	    style = GetWindowLong( win, GWL_STYLE );
	    DPRINTF(("style retrieved %x\n", style ));
	    if (style) {
		if( aBool == true ) {
		    /* set clip by child */

		    style = style | WS_CLIPCHILDREN;
		} else {
		    style = style &~ WS_CLIPCHILDREN;
		}

		if( ( oldstyle = SetWindowLong( win, GWL_STYLE, style ) ) == 0 ) {
		    DPRINTF(("clipping by child failed - could not set value\n"));
		} else {
		    DDPRINTF(("Style set %x OLD STYLE: %x\n", style, oldstyle ));
		}
	    } else {
		DPRINTF(("clipping by child failed - could not retrieve style\n"));
	    }
	} else {
	    DPRINTF(("clipping by child failed - invalid win\n" ));
	}
    }
#endif
%}.
    ^ self
!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:aDrawableId gc:aGCId
    "clip to a rectangle"

"
      p--w---
      |     |
      h     |  the clipping rectangle
      |     |
      -------
	  where p = ( clipX, clipY ), w = clipWidth, h = clipHeight
"

%{  /* NOCONTEXT */

    HDC   hDC;
    HRGN  region = NULL;
    int   x, y;

    if (  __isExternalAddress(aGCId)
       && __bothSmallInteger(clipX, clipY)
       && __bothSmallInteger(clipWidth, clipHeight) ) {
	struct gcData *gcData = _GCDATA(aGCId);
	hDC = _HDCVal(aGCId);
	x = __intVal(clipX);
	y = __intVal(clipY);

	region = CreateRectRgn( x, y, 
				( x + __intVal(clipWidth) ), 
				( y + __intVal(clipHeight) ) );
	if( region == NULL ) {
	    DPRINTF((" clipping region creation failed!\n"));
	} else {
	    if( SelectClipRgn( hDC, region ) == 0 ) {
		DPRINTF((" clipping region setting unsuccessful\n" ));
	    }
	}
	if (gcData->clipRgn) {
	    DeleteObject(gcData->clipRgn);
	}
	gcData->clipRgn = region;
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setDashes:dashList dashOffset:offset in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("dashes not yet implemented\n"));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setFont:aFontId in:aGCId
    "set font to be drawn in"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aFontId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HGDIOBJ hFont;
	TEXTMETRIC tmet;

	hDC = gcData->hDC;
	hFont = _HGDIOBJVal(aFontId);

	SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tmet);
	gcData->fontAscent = tmet.tmAscent;
	DPRINTF(("setFont: %x\n", hFont));
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex in:aGCId
    "set foreground and background colors to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = gcData->hDC;

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil)"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId lineWidth:lw in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil); also set lineWidth"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	if (__intVal(lw) != gcData->lineWidth) {
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    gcData->lineWidth = __intVal(lw);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex in:aGCId
    "set foreground color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	DDPRINTF(("setForeground: %x\n", fgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setFunction:aFunctionSymbol in:aGCId
    "set alu function to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;
    int fun;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	if (aFunctionSymbol == @symbol(copy)) fun = R2_COPYPEN;
	else if (aFunctionSymbol == @symbol(copyInverted)) fun = R2_NOTCOPYPEN;
	else if (aFunctionSymbol == @symbol(xor)) fun = R2_XORPEN;
	else if (aFunctionSymbol == @symbol(and)) fun = R2_MASKPEN;
	else if (aFunctionSymbol == @symbol(andReverse)) fun = R2_MASKPENNOT;
	else if (aFunctionSymbol == @symbol(andInverted)) fun = R2_NOTMASKPEN;
	else if (aFunctionSymbol == @symbol(or)) fun = R2_MERGEPEN;
	else if (aFunctionSymbol == @symbol(orReverse)) fun = R2_MERGEPENNOT;
	else if (aFunctionSymbol == @symbol(orInverted)) fun = R2_NOTMERGEPEN;
	if (fun != -1) {
	    SetROP2(hDC, fun);
	}
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setGraphicsExposures:aBoolean in:aGCId
    "set or clear the graphics exposures flag"

!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)
     && __isSmallInteger(aNumber)) {
	struct gcData *gcData = _GCDATA(aGCId);
	hDC = _HDCVal(aGCId);

	if (gcData->hPen) {
	    DeleteObject(gcData->hPen);
	    gcData->hPen = (HBRUSH)0;
	}

	gcData->lineWidth = __intVal(aNumber);
	if (lineStyle == @symbol(solid)) {
	    gcData->lineStyle = PS_SOLID;
	} else if (lineStyle == @symbol(dashed)) {
	    gcData->lineStyle = PS_DASH;
	} else
	    gcData->lineStyle = PS_DASH;

	if (capStyle == @symbol(round)) {
	    gcData->capStyle = PS_ENDCAP_ROUND;
	} else if (capStyle == @symbol(square)) {
	    gcData->capStyle = PS_ENDCAP_SQUARE;
	} else if (capStyle == @symbol(flat)) {
	    gcData->capStyle = PS_ENDCAP_FLAT;
	} else
	    gcData->capStyle = PS_ENDCAP_FLAT;

	if (joinStyle == @symbol(bevel)) {
	    gcData->joinStyle = PS_JOIN_BEVEL;
	} else if (joinStyle == @symbol(miter)) {
	    gcData->joinStyle = PS_JOIN_MITER;
	} else if (joinStyle == @symbol(round)) {
	    gcData->joinStyle = PS_JOIN_ROUND;
	} else
	    gcData->joinStyle = PS_JOIN_MITER;

	RETURN (self);
    }
%}.
    self primitiveFailed
!

setMaskOriginX:orgX y:orgY in:aGCId
    "set the mask origin"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("mask origin not yet implemented\n"));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setPixmapMask:aPixmapId in:aGCId
    "set or clear the drawing mask - a pixmap mask providing full color"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("pixmask origin not yet implemented\n"));
	RETURN (self);
    }
%}.
    self primitiveFailed
! !

!WinWorkstation methodsFor:'initialize / release'!

close
    "close down the connection to the X-server"

!

initializeDefaultValues
    focusMode := #activeWindow.

    buttonTranslation := ButtonTranslation.
    multiClickTimeDelta := MultiClickTimeDelta.

    self initializeModifierMappings
!

initializeEventBuffer
!

initializeFor:aDisplayName
    "initialize the receiver for a connection to an X-Server;
     the argument, aDisplayName may be nil (for the default server from
     DISPLAY-variable or command line argument) or the name of the server 
     as hostname:number"

%{
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int rgbVisualID;
    int nvi, i;
    int shapeEventBase, shapeErrorBase;
    int shmEventBase, shmErrorBase;
    int faxEventBase, faxErrorBase;
    char *type, *nm;
    int dummy;
    OBJ dpyID;

    if (__INST(displayId) != nil) {
	/*
	 * already connected - you bad guy try to
	 * trick me manually ?
	 */
	RETURN ( self );
    }

    __INST(displayId) = __MKSMALLINT(1);

%}.

    dispatching := false.
    isSlow := false.
    shiftDown := false.
    ctrlDown := false.
    metaDown := false.
    altDown := false.
    motionEventCompression := true.
    buttonsPressed := 0.

    self initializeScreenProperties.
    self initializeDeviceResourceTables.

    self initializeDefaultValues.
    self initializeEventBuffer.
    self initializeSpecialFlags.
    self initializeKeyboardMap.
!

initializeModifierMappings
    shiftModifiers := #(#'Shift_L' #'Shift_R' #'Shift').
    ctrlModifiers := #(#'Ctrl_L' #'Ctrl_R' #'Ctrl').
    metaModifiers := #(#'Alt_L' #'Alt').
    altModifiers := #(#'Alt_R').
!

initializeScreenProperties
    super initializeScreenProperties.

%{  /* NOCONTEXT */

    int scr;
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int nvi, i, val, capabilities, __depth;
    char *type, *nm;
    int dummy;
    int mask, shift, nBits;
    HWND _rootWin = NULL;
    RECT rect;
    HDC _rootDC;
    OBJ id;

    _rootWin = GetDesktopWindow();
    __INST(rootWin) = id = __MKOBJ(_rootWin); __STORE(self, id);

    _rootDC = CreateDC("DISPLAY", NULL, NULL, NULL);
    __INST(rootDC) = id = __MKOBJ(_rootDC); __STORE(self, id);

    GetWindowRect(_rootWin, &rect);
    __INST(width) = __MKSMALLINT(rect.right-rect.left);
    __INST(height) = __MKSMALLINT(rect.bottom-rect.top);
    printf("screen is %d/%d\n", __intVal(__INST(width)), __intVal(__INST(height)));

    __depth = GetDeviceCaps(_rootDC, BITSPIXEL);

    __INST(depth) = __MKSMALLINT(__depth);
    __INST(ncells) = __MKSMALLINT(1<<__depth);

    val = GetDeviceCaps(_rootDC, HORZSIZE);
    __INST(widthMM) = __MKSMALLINT(val);
    val = GetDeviceCaps(_rootDC, VERTSIZE);
    __INST(heightMM) = __MKSMALLINT(val);


    capabilities = GetDeviceCaps(_rootDC, RASTERCAPS);

    __INST(whitepixel) = __MKSMALLINT(RGB(0xFF, 0xFF, 0xFF));
    __INST(blackpixel) = __MKSMALLINT(RGB(0,0,0));

    if (! (capabilities & RC_PALETTE)) {
	DPRINTF(("no palette\n"));
	if (__depth == 1) {
	    __INST(visualType) = @symbol(GrayScale);
	    __INST(hasColors) = false;
	    __INST(hasGreyscales) = false;
	    __INST(monitorType) = @symbol(monochrome);
	} else {
	    __INST(visualType) = @symbol(TrueColor);
/*
	    __INST(visualType) = @symbol(StaticColor);
*/
	    __INST(hasColors) = true;
	    __INST(hasGreyscales) = true;
	}
    } else {
	val = GetDeviceCaps(_rootDC, SIZEPALETTE); /* First two entries are black and white. */

	__INST(ncells) = __MKSMALLINT(val);
	__INST(blackpixel) = __MKSMALLINT(0);
	__INST(whitepixel) = __MKSMALLINT(1);
	__INST(hasColors) = true;
	__INST(hasGreyscales) = true;
    }      

    __INST(monitorType) = @symbol(unknown);

    __INST(redShift) = __MKSMALLINT(0);
    __INST(greenShift) = __MKSMALLINT(8);
    __INST(blueShift) = __MKSMALLINT(16);
    __INST(bitsPerRGB) = __MKSMALLINT(16);
    __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(8);
    __INST(redMask) = __MKSMALLINT(0xFF);
    __INST(greenMask) = __MKSMALLINT(0xFF00);
    __INST(blueMask) = __MKSMALLINT(0xFF0000);

    __INST(resizeFrameWidth) = __MKSMALLINT(GetSystemMetrics(SM_CXFRAME));
    __INST(resizeFrameHeight) = __MKSMALLINT(GetSystemMetrics(SM_CYFRAME));
    __INST(dialogFrameWidth) = __MKSMALLINT(GetSystemMetrics(SM_CXDLGFRAME));
    __INST(dialogFrameHeight) = __MKSMALLINT(GetSystemMetrics(SM_CYDLGFRAME));
    __INST(noResizeFrameWidth) = __MKSMALLINT(GetSystemMetrics(SM_CXBORDER));
    __INST(noResizeFrameHeight) = __MKSMALLINT(GetSystemMetrics(SM_CYBORDER));
    __INST(captionHeight) = __MKSMALLINT(GetSystemMetrics(SM_CYCAPTION));
DPRINTF(("fW=%d fH=%d dW=%d dH=%d bW=%d bH=%d cH=%d\n",
	    __intVal(__INST(resizeFrameWidth)),
	    __intVal(__INST(resizeFrameHeight)), 
	    __intVal(__INST(dialogFrameWidth)),
	    __intVal(__INST(dialogFrameHeight)), 
	    __intVal(__INST(noResizeFrameWidth)),
	    __intVal(__INST(noResizeFrameHeight)),
	    __intVal(__INST(captionHeight)) 
       ));
%}.
!

initializeSpecialFlags
    "perform additional special server implementation flags"
!

reinitialize
    rootWin := rootDC := nil.
    super reinitialize.
! !

!WinWorkstation methodsFor:'keyboard mapping'!

altModifierMask
    "return the mask (in motionEvents) for the alt-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(AltMask));
%}

    "Created: 23.3.1996 / 12:43:22 / cg"
    "Modified: 23.3.1996 / 12:44:56 / cg"
!

metaModifierMask
    "return the mask (in motionEvents) for the meta-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(MetaMask));
%}

    "Created: 23.3.1996 / 12:43:39 / cg"
    "Modified: 23.3.1996 / 12:45:09 / cg"
!

leftAltMask
    "return the mask bit for the left Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(LeftAltMask));
%}
!

rightAltMask
    "return the mask bit for the right Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(RightAltMask));
%}
!

modifierMapping
    "Get the Modifier Mapping.
     We return an array of arrays of keycodes"

    ^ nil
!

stringFromKeycode:code
    "Get a KeySymbol (a smalltalk symbol) from the keycode."

    ^ ''

    "
	Display stringFromKeycode:28
    "
!

translateKey:untranslatedKey
    |key|

    (key := untranslatedKey) isCharacter ifFalse:[
	key := RawKeysymTranslation at:key ifAbsent:key.
	key := key asSymbol.
'key - xlated: ' print. untranslatedKey print. ' to: ' print. key printCR.
    ].
    ^ super translateKey:key
! !

!WinWorkstation methodsFor:'misc'!

beep
    "output an audible beep or bell"

    self beep:50
!

beep:volumeInPercent
    "output an audible beep"
%{
    Beep(__intVal(@global(BeepFrequency)), __intVal(@global(BeepDuration)));
%}
!

refreshKeyboardMapping:eB
!

setInputFocusTo:aWindowId
    self setInputFocusTo:aWindowId revertTo:nil
!

setInputFocusTo:aWindowId revertTo:revertSymbol
    "set the focus to the view as defined by aWindowId.
     Passing nil set the focus to no window and lets the display discard all
     input until a new focus is set.
     RevertSymbol specifies what should happen if the view becomes invisible;
     passing one of #parent, #root or nil specifies that the focus should be
     given to the parent view, the root view or no view."

%{
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetFocus(hWnd);
	}
	RETURN ( self );
    }
%}
! !

!WinWorkstation methodsFor:'pointer queries '!

anyButtonStateMask
    "return an integer for masking out any button from a
     buttonStates value."

    "/ should use ``Display buttonXMotionMask bitOr:....''

    ^ 256 + 512 + 1024

    "Modified: 23.3.1996 / 12:41:33 / cg"
    "Created: 23.3.1996 / 12:46:35 / cg"
!

buttonStates
    "return an integer representing the state of the pointer buttons;
     a one-bit in positions 0.. represent a pressed button.
     See the button1Mask/button2Mask/button3Mask,
     shiftMask/controlMask and modifierMask methods for the meaning of the bits."

    ^ 0

    "
     Display buttonStates     
    "

    "is the control-key pressed ?

     Display buttonStates bitTest:(Display controlMask)    
    "

    "is the alt/meta-key pressed ?

     Display buttonStates bitTest:(Display altModifierMask)    
     Display buttonStates bitTest:(Display metaModifierMask)    
    "
!

leftButtonStateMask
    "return an integer for masking out the left button from a
     buttonStates value"

    "/ should use ``Display button1MotionMask''

    ^ 256

    "Modified: 23.3.1996 / 12:41:33 / cg"
!

middleButtonStateMask
    "return an integer for masking out the middle button from a
     buttonStates value"

    "/ should use ``Display button2MotionMask''

    ^ 512

    "Modified: 23.3.1996 / 12:41:43 / cg"
!

pointerPosition
    "return the current pointer position in root-window coordinates"

    |xpos ypos|
%{
    POINT p;

    if (GetCursorPos(&p)) {
	xpos = __MKSMALLINT(p.x);
	ypos = __MKSMALLINT(p.y);
    } else {
	xpos = ypos = __MKSMALLINT(0);
    }
%}.
    ^ xpos @ ypos
!

rightButtonStateMask
    "return an integer for masking out the right button from a
     buttonStates value"

    "/ should use ``Display button3MotionMask''

    ^ 1024

    "Modified: 23.3.1996 / 12:41:52 / cg"
!

rootPositionOfLastEvent
    "return the position in root-window coordinates
     of the last button, key or pointer event"

    |x y|

%{
    x = __MKSMALLINT(evRootX);
    y = __MKSMALLINT(evRootY);
%}.
    ^ x @ y
!

setPointerPosition:newPosition
    "change the pointer position in root-window coordinates."

    |xpos ypos|

    xpos := newPosition x.
    ypos := newPosition y.
%{
    if (__bothSmallInteger(xpos, ypos)) {
        SetCursorPos(__intVal(xpos), __intVal(ypos));
    }
%}.
    ^ self
!

setPointerPosition:newPosition in:aWindowId
    "change the pointer position to a new position relative to the
     given windows origin (which may be the rootWindow).
     Be careful with this - its usually not very ergonimically
     to change the mousePointer position.
     This interface is provided for special applications (presentation
     playback) and should not be used in normal applications."

    self setCursorPosition:(self translatePoint:newPosition from:aWindowId to:rootView id).
! !

!WinWorkstation methodsFor:'retrieving pixels'!

getBitsFromPixmap:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil 
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFromPixmap:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getBitsFromId:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getPixelX:x y:y from:aDrawableId
    "return the pixel value at x/y; coordinates start at 0/0 for the upper left.
     Nil is returned for invalid coordinates or if any other problem arises."

    ^ nil
!

primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."
 
	^ false
! 

primGetBitsFromPixmap:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */
    int            height, width;
    int            numBytes;
    unsigned char* ep = 0;
    HBITMAP        xBitMap;

    if (ISCONNECTED
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(srcx, srcy)
     && __bothSmallInteger(w, h)
     && __isArray(info)
     && __isByteArray(imageBits)) {

/* if BITMAP */

	xBitMap = _HBITMAPVAL( aDrawableId );
	if( xBitMap != 0 )
	{
	    height =  __intVal(h) -  __intVal(srcy);
	    width  = ( ( __intVal(w) -  __intVal(srcx) ) + 15 ) / 16; /* in Bytes */
	    numBytes = height * 2 * width;
	    if( numBytes != 0 )
	    {
		if( ep = (unsigned char *) malloc(numBytes) )
		{
		    if( numBytes = GetBitmapBits( xBitMap, numBytes, ep ) == 0 )
		    {
			printf("zero bits returned\n");
			goto fail;
		    }
		}
		else
		{
		    printf("malloc failed\n");
		    goto fail;
		}
	    }
	    else
	    {
		printf("unacceptable bitmap\n");
		goto fail;
	    }
	}
	else
	{
	    printf("unacceptable bitmap\n");
	    goto fail;
	}

	if (numBytes > __byteArraySize(imageBits)) {
	    /* imageBits too small */
	    printf("provided byteArray too small\n");
	    goto fail;
	}
	__ArrayInstPtr(info)->a_element[0] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[1] = __MKSMALLINT(1);
	__ArrayInstPtr(info)->a_element[2] = __MKSMALLINT(width);
	__ArrayInstPtr(info)->a_element[3] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[4] = @symbol(XYBitmap);
	__ArrayInstPtr(info)->a_element[5] = __MKSMALLINT(0);
	__ArrayInstPtr(info)->a_element[6] = __MKSMALLINT(16);
	__ArrayInstPtr(info)->a_element[7] = __MKSMALLINT(1);
	bcopy(ep, __ByteArrayInstPtr(imageBits)->ba_element, numBytes);
	free( ep );
	RETURN ( true );
    }
fail: 
    if (ep) {
	free( ep );
    }
%}.
    ^ false
! !

!WinWorkstation methodsFor:'window stuff'!

clearRectangleX:x y:y width:width height:height in:aWindowId
    "clear a rectangular area to viewbackground"
%{
    DPRINTF(("clearRect\n"));
%}.
    super clearRectangleX:x y:y width:width height:height in:aWindowId
!

clearWindow:aWindowId
    "clear a window to viewbackground"

%{
    DPRINTF(("clearWin\n"));
%}.
    super clearWindow:aWindowId
!

configureWindow:aWindowId sibling:siblingId stackMode:modeSymbol
    "configure stacking operation of aWindowId w.r.t siblingId"

!

lowerWindow:aWindowId
    "bring a window to back"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);

	    BringWindowToTop(win);
	}
	RETURN ( self );
    }
%}.

!

mapView:aView id:aWindowId iconified:aBoolean atX:xPos y:yPos width:w height:h
    "make a window visible - either as icon or as a real view - needed for restart"

    'mapView:id:iconified:...height: not yet implemented' errorPrintCR.
!

mapWindow:aWindowId
    "make a window visible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_SHOW);
/*
	    enqEvent(win, WM_SHOWWINDOW, TRUE, 0, 0, 0, 0);
*/
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

moveResizeWindow:aWindowId x:x y:y width:w height:h
    "move and resize a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(w, h)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, (HWND)0, 
			 __intVal(x), __intVal(y),
			 __intVal(w), __intVal(h),
			 SWP_NOACTIVATE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

moveWindow:aWindowId x:x y:y
    "move a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, (HWND)0,
			 __intVal(x), __intVal(y),
			 0, 0,
			 SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

raiseWindow:aWindowId
    "bring a window to front"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetWindowPos(hWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

resizeWindow:aWindowId width:w height:h
    "resize a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(w, h)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetWindowPos(hWnd, (HWND)0, 
			 0, 0, 
			 __intVal(w), __intVal(h), 
			 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

setBackingStore:how in:aWindowId
    "turn on/off backing-store for a window"

!

setBitGravity:how in:aWindowId
    "set bit gravity for a window"

!

setCursor:aCursorId in:aWindowId
    "define a windows cursor"

%{  /* NOCONTEXT */

    HCURSOR newCursor;

    if (ISCONNECTED
     && __isExternalAddress(aWindowId)
     && __isExternalAddress(aCursorId)) {
/*        XDefineCursor(dpy, _WindowVal(aWindowId), _CursorVal(aCursorId)); */
	newCursor = SetCursor(_HCURSORVal(aCursorId));
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

setIconName:aString in:aWindowId
    "define a windows iconname"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
	HWND win = _HWNDVal(aWindowId);

	SetWindowText(win, __stringVal(aString));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setSaveUnder:yesOrNo in:aWindowId
    "turn on/off save-under for a window"

!

setTransient:aWindowId for:aMainWindowId
    "set aWindowId to be a transient of aMainWindow"

!

setWindowBackground:aColorIndex in:aWindowId
    "set the windows background color. This is the color with which
     the view is filled whenever exposed. Do not confuse this with
     the background drawing color, which is used with opaque drawing."

!

setWindowBackgroundPixmap:aPixmapId in:aWindowId
    "set the windows background pattern to be a form.
     This is the pattern with which the view is filled whenever exposed. 
     Do not confuse this with the background drawing color, which is used 
     with opaque drawing."

!

setWindowBorderColor:aColorIndex in:aWindowId
    "set the windows border color"

!

setWindowBorderPixmap:aPixmapId in:aWindowId
    "set the windows border pattern"

!

setWindowBorderWidth:aNumber in:aWindowId
    "set the windows border width"

!

setWindowClass:wClass name:wName in:aWindowId
    "define class and name of a window.
     This may be used by the window manager to
     select client specific resources."

!

setWindowGravity:how in:aWindowId
    "set window gravity for a window"

!

setWindowIcon:aForm in:aWindowId
    "define a bitmap to be used as icon"

    |wiconId wiconHeight wiconWidth|

    aForm notNil ifTrue:[
	wiconId := aForm id.
	wiconHeight := aForm height.
	wiconWidth  := aForm width.
    ].

%{  /* NOCONTEXT */

    unsigned char* cp;
    unsigned char* ep;
    HBITMAP        xBitMap;
    int            height, width;
    int            nBytes, nBits;
    int            index;
    HICON          xIcon = (HICON)0, yIcon = (HICON)0;

    if (__isExternalAddress(aWindowId)
     && (__isExternalAddress(wiconId))) {
	HWND win = _HWNDVal(aWindowId);

	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 )
	{
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 15 ) / 16;
	    nBytes = height * 2 * nBytes;
	    if( nBytes != 0 )
	    {
		cp = (unsigned char *) malloc(nBytes);
		ep = (unsigned char *) malloc(nBytes);
		if( ( cp != 0 ) && ( ep != 0 ) )
		{
		    for( index = 0; index < nBytes; index++ )
			*ep++ = 0x00;
		    nBits = GetBitmapBits( xBitMap, nBytes, cp );
		    xIcon = CreateIcon( (HANDLE) __getHInstance(),
					width,
					height,
					1,
					1,
					ep,
					cp );
		    DPRINTF(( "ICON CREATED\n"));
		    DPRINTF(( "xIcon: %d, height: %d, width: %d\n" ));
		}
		else
		{
		    DPRINTF(( " malloc failed\n" ));
		}
	    }
	    else
	    {
		DPRINTF(( " nBytes is zero \n" ));
	    }
	}
	else
	{
	    DPRINTF((" xBitMap is zero \n" ));
	}

	if (xIcon) {
#if 0
	    yIcon = (HICON) DefWindowProc( win, WM_SETICON, ICON_BIG, (long) xIcon );
#endif
	    yIcon = Static_GetIcon(win);
	    Static_SetIcon(win, 0);

/* It has to be checked whether thia can be deleted!!!!! */
	    if( yIcon ) {
		if( DestroyIcon( yIcon ) )
		    DPRINTF(( "Old icon deleted\n" ));
	    }
	}
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setWindowIconWindow:aView in:aWindowId
    "define a window to be used as icon"

!

setWindowName:aString in:aWindowId
    "define a windows name"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
	HWND win = _HWNDVal(aWindowId);

	SetWindowText(win, __stringVal(aString));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

unmapWindow:aWindowId
    "make a window invisible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_HIDE);
/*
	    enqEvent(win, WM_SHOWWINDOW, FALSE, 0, 0, 0, 0);
*/
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
! !

!WinWorkstation  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/WinWorkstat.st,v 1.32 1997-10-13 13:28:29 cg Exp $'
! !

WinWorkstation initialize!
